#include "Calcule.h"
#include "FichePersoJoueur.h"
#include "ProjetdeBaseApp.h"

//---------------------------------------------------------------------------
//      Utilitaires
//---------------------------------------------------------------------------
         wxString TAB=wxString(wxT("         "));
        //---------------------------------------------------------------------------
        // normalise une valeur entre mini et maxi
        template<class Te> Te normalise(Te mini,Te maxi,Te r)
        {
        r=(r<mini?mini:r);
        r=(r>maxi?maxi:r);
        return r;
        }
//---------------------------------------------------------------------------
        bool teste_plan_bateau(plan_bateau p,bool affichage)
        {
            bool valide(true);
            wxString messagecorrect(wxT("plan valide"));
            int taille=taille_echiquier_courant();
        unsigned int lon=p.size();
        if(lon)
                for (unsigned int i=0;i<lon;i++)
                    {
                    if (affichage)
                        {wxChar c1=wxChar(int('a'+p[i]->abs()));
                        wxChar c2=wxChar(int('0'+p[i]->ord()));
                        wxString li=(wxT("case ")+wxString::Format(wxT("%1i"),i+1)+wxT(" -> ")+c1+wxT(" ")+c2);
                        firstwin()->Dialogues->AppendText(li+LF);
                        };
                    valide=valide&&(p[i]->abs()>=0);
                    valide=valide&&(p[i]->ord()>=0);
                    valide=valide&&(p[i]->abs()<taille);
                    valide=valide&&(p[i]->ord()<taille);
                    }
        if (!valide) messagecorrect=wxT("plan invalide");
        firstwin()->Dialogues->AppendText(messagecorrect);
        return valide;
        }
//---------------------------------------------------------------------------
        // uniquement utile en test
        void teste_personnalite(Tpersonnalite p)
        {float vp[5][5] __attribute__ ((unused));
        for (int i=0;i<5;i++)
                for (int j=0;j<5;j++)
                        vp[i][j]=p.profile[i][j];

        }
//---------------------------------------------------------------------------
        // Teste Liste joueur
        void test_listejoueur(Tliste_joueurs j)
        {
            int nb=0;
            nb=j.size();
            if (nb) teste_personnalite(j[0]);
        }

//---------------------------------------------------------------------------
//      Fin Utilitaires
//---------------------------------------------------------------------------
//      Début de namespace Scrutateur
//---------------------------------------------------------------------------
        // contient les fonctions qui examinent la qualité de la disposition des bateaux
namespace Scrutateur
{
        double vmax=taille_grille_profiles();// valeur maxi de sortie des fonctions d'évaluations

        //---------------------------------------------------------------------------
        double fignole (double v)
        // repousse les petits dépassements dans des valeurs proches du bord de la grille
        {
        int marge=int(vmax-2);
        if (v<=(vmax-0.5)&&(v>=0.5)) return v;
        bool tropfort=(v>(vmax-0.5));
        double ecart=(tropfort?-1:0)*vmax+0.5+(tropfort?1:-1)*v;
        double correction=ecart/marge*0.5;
        double resultat= v + (ecart-correction)*(tropfort?-1:1);
        return resultat;
        }
        //---------------------------------------------------------------------------
        double ajuste_profile(int taille,int forme,bool compacite,double valeur)
        // coefficient [taille][forme][compac margin][min max]
        // Fait renter les valeurs brutes de compacité et marginalité dans une grille [0 vmax[
        {
        int coefficient[3][3][2][2]=
                {{{{0,5},{2,5}},{{0,5},{2,5}},{{0,5},{2,5}}},  // taille 5 L T Fumette
                {{{0,4},{0,4}},{{1,5},{1,4}},{{0,5},{1,4}}},   // taille 10 L T Fumette
                {{{0,2},{0,5}},{{1,4},{0,5}},{{0,4},{0,5}}}};  // taille 12 L T Fumette
        int comp=(compacite?0:1);
        taille=normalise(0,3,taille);
        forme=normalise(0,3,forme);
        vecteur corrige(coefficient[taille][forme][comp][0],coefficient[taille][forme][comp][1]);
        valeur=(valeur-corrige.real())/(corrige.imag()-corrige.real()+0.001)*vmax;
        valeur=fignole(valeur);
        valeur=normalise(0.0,(vmax-0.001),valeur); //valeurs sur [0  vmax[
        return valeur;
        }
        //---------------------------------------------------------------------------
        double nb_cases_interdites_maxi(int n,int m)
        // détermine le nombre de cases interdites au voisinage d'un bateau de longueur n
        // et de mode m, m étant 1 (coin), 2 (marginal) 3(droit) 4 (tordu ou par les côtés)
        // les valeurs des coefficients coeff1 et coeff 2 ont été déterminées empiriquement
        {double resultat=(n+1.68)*m*0.85;
        return resultat;
        }
        //---------------------------------------------------------------------------
        double nb_cases_interdites_mini(int n,int m)
        // détermine le nombre de cases interdites au voisinage d'un bateau de longueur n
        // et de mode m, m étant 0 (coin), 1 (marginal) 2(droit) 3 (tordu ou par les côtés)
        // les valeurs des coefficients coeff1 et coeff 2 ont été déterminées empiriquement
        {double resultat=(n+0.48)*m*0.7;
        return resultat;
        }
        //---------------------------------------------------------------------------
        double Nb_cases_interdites_mini_flottille(Tflottille& f)
        // retourne l'évaluation théorique du nombre maximum de cases interdites autour
        // des bateaux de la flottille f
        // effet de bord non pris en compte
        {double resultat=0;
        for (unsigned int i=0;i<f.size();i++)
                {
                resultat+=nb_cases_interdites_mini(f[i].taille,f[i].mode());
                //resultat-=f[i].nb_cotes_au_bord();
                }
        return resultat;
        }
        //---------------------------------------------------------------------------
        double Nb_cases_interdites_maxi_flottille(Tflottille& f)
        // retourne l'évaluation théorique du nombre minimum de cases interdites autour
        // des bateaux de la flottille f
        // effet de bord non pris en compte
        {double resultat=0;
        for (unsigned int i=0;i<f.size();i++)
                {
                resultat+=nb_cases_interdites_maxi(f[i].taille,f[i].mode());
                //resultat-= (f[i].nb_cotes_au_bord()>0?1:0);
                }
        return resultat;
        }
        //---------------------------------------------------------------------------
        int nb_cases_interdites_effectif(TJeu* j)
        {
            bateau resultat,b1,b2,b3;
        for (unsigned int i=0;i<j->flottille.size();i++)
             {b1.plan=j->son_tableau.liste_voisins(&j->flottille[i],par_les_sommets,interdite);
              b2.plan=j->son_tableau.liste_voisins(&j->flottille[i],par_les_sommets,jouee);
              b3.plan=j->son_tableau.liste_voisins(&j->flottille[i],par_les_sommets,libre);
              b1.taille=b1.plan.size();
              b2.taille=b2.plan.size();
              b3.taille=b3.plan.size();
              resultat+=b1+b2+b3;
             }
        return resultat.taille;
        }
        //---------------------------------------------------------------------------
        // retourne la compacité de la flottille du jeu j notée de [0 (dispersée) à [vmax (compacte)
        double compacite_flottille(TJeu* j)
        {double resultat(0);
        double nb_max,nb_min,nb_eff;
        nb_max=Nb_cases_interdites_maxi_flottille(j->flottille);
        nb_min=Nb_cases_interdites_mini_flottille(j->flottille);
        nb_eff=nb_cases_interdites_effectif(j);
        resultat= (nb_max-nb_eff)/(nb_max-nb_min+0.001)*nb_min/(nb_eff+0.001)*vmax;
        //Ajuste la valeur pour éviter les valeurs impossibles
        bateau b;
        resultat=ajuste_profile(firstwin()->ChoixTaille->GetSelection(),b.forme(),true,resultat);
        return resultat;
        }
        //---------------------------------------------------------------------------
        // retourne la marginalité des bateaux du jeu jeu (les cases qui touchent les côtés) notée de [0 à [vmax
        double marginalite_flottille(TJeu* jeu)
        {
        int nb_cases(0),nb_cases_marginales(0);
        for (unsigned int i=0;i<jeu->flottille.size();i++)
                nb_cases+=jeu->flottille[i].taille;
        for (unsigned int i=0;i<jeu->flottille.size();i++)
                {bateau b=jeu->flottille[i];
                for(unsigned int j=0;j<b.plan.size();j++)
                        if (b.plan[j]->case_au_bord()) nb_cases_marginales++;
                }
        double resultat=(nb_cases_marginales/(nb_cases+0.001))*vmax+0.5;
        // Ajuste la valeur pour éviter les valeurs impossibles
        bateau b;
        resultat=ajuste_profile(firstwin()->ChoixTaille->GetSelection(),b.forme(),false,resultat);
        return resultat;
        }
        //---------------------------------------------------------------------------
        bool met_a_jour_personnalite(TJeu* j,bool vainqueur)
        {bool reponse=(j->flottille.size()>0);
        if (reponse)
                {
                int c=int(compacite_flottille(j));
                int m=int(marginalite_flottille(j));
                j->ajoute_valeur_personnalite(c,m,vainqueur);
                }
        return reponse;
        }
}
//---------------------------------------------------------------------------
//      Fin namespace Scrutateur
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Debut namespace  Strategies
//---------------------------------------------------------------------------
// Règle les modalités du jeu d'un coup
// Détail des règles du jeu (formes des bateaux ...)
// Choisit comment utiliser l'évaluation donné par Scrutateur
namespace Strategies
{
//---------------------------------------------------------------------------
        // renvoie une coordonnée (comp,marg) en respectant les probabilités de chaque doublet
        // indiquées par la personnalité transmise en paramètre.
        // Bug RandomRange corrigé (retourne des valeurs dans [min,max[
        // au lieu de [min,max] comme indiqué dans la documentation
        wxPoint grille_favorite_de(Tpersonnalite p)
        {
        int Lprofile=taille_grille_profiles();
        int valeurcase=int(100/(Lprofile*Lprofile));
        wxPoint abaque[100];
        for (int i=0;i<100;i++) abaque[i]=wxPoint(0,0);
        // cherche la valeur mini
        double min=10000;
        for (int i=0;i<Lprofile;i++)
                for (int j=0;j<Lprofile;j++)
                        if (p.profile[i][j]<min) min=p.profile[i][j];
        // Ajuste le mini à 0
        for (int i=0;i<Lprofile;i++)
                for (int j=0;j<Lprofile;j++) p.profile[i][j]-=min;
        // ajuste les valeurs pour que leur somme soit 100
        double total=0;
        for (int i=0;i<Lprofile;i++)
                for (int j=0;j<Lprofile;j++)total+=p.profile[i][j];
        if (total)
                for (int i=0;i<Lprofile;i++)
                        for (int j=0;j<Lprofile;j++)p.profile[i][j]*=(100/total);
            else // si toutes les valeurs sont égales (total=0) met 4% dans toutes les cases
                for (int i=0;i<Lprofile;i++)
                        for (int j=0;j<Lprofile;j++)p.profile[i][j]=valeurcase;
        // remplit l'abaque d'un nombre de wxPoint proportionnel à la proba de la personnalité concernée
        int indice=0;
        for (int i=0;i<Lprofile;i++)
                for (int j=0;j<Lprofile;j++)
                        for (int k=0;k<(p.profile[i][j]-0.5);k++)
                                {
                                abaque[indice]=wxPoint(i,j);
                                if (indice<99) indice++;
                                }
        return abaque[RandomRange_bis(0,100)];
        }
//---------------------------------------------------------------------------
// Début implémentation de la classe donnees_strategies
// Fournit des données globales à travers ses membres static
//---------------------------------------------------------------------------
        std::vector<int>& donnees_strategies::structure_flottille_complete()
        {
            static std::vector<int> sf;
            return sf;
        }
        //---------------------------------------------------------------------------
        int& donnees_strategies::taille_max_bateau()
        {
            static int tmxb(4);
            return tmxb;
        }
        // Retournera 144 avec la version actuelle
        int donnees_strategies::taille_max_tableau()
            {
            return taille_max_admissible_grille*taille_max_admissible_grille;
            }
        // fixe le nombre des différents bateaux
        void donnees_strategies::fixe_structure_flottille(int t1,int t2,int t3,int t4)
                {
                structure_flottille_complete().clear();
                structure_flottille_complete().push_back(t1);
                structure_flottille_complete().push_back(t2);
                structure_flottille_complete().push_back(t3);
                structure_flottille_complete().push_back(t4);
                taille_max_bateau()=0;
                for (unsigned int i=0;i<structure_flottille_complete().size();i++)
                    if (structure_flottille_complete()[i]) taille_max_bateau()=i+1;
                }
        //---------------------------------------------------------------------------
        // Ajuste la flottille à la taille de la grille
        void donnees_strategies::ajuste_flottille_a_grille()
        {
        switch (taille_echiquier_courant())
                {
                case  5:fixe_structure_flottille(2,1,1,0);break;
                case 10:fixe_structure_flottille(4,3,2,1);break;
                case 12:fixe_structure_flottille(4,3,2,1);break;
                default:fixe_structure_flottille(2,1,1,0);
                }
        }
        //---------------------------------------------------------------------------
        wxString donnees_strategies::nom_reponse(types_reponses rep)
                {//retourne le nom du type de réponse à un coup
                Traducteur tr;
                return tr.trad(noms_reps[rep]);
                }
        //---------------------------------------------------------------------------
        // fonctions de lecture et modification de la forme des bateaux
        types_de_bateaux donnees_strategies::forme_bateaux()
                {
                bateau b;
                return b.forme();
                }
        void donnees_strategies::fixe_forme_bateaux(types_de_bateaux typ)
                {
                bateau b;
                b.forme()=typ;
                }
        //---------------------------------------------------------------------------
        bool& donnees_strategies::machine_contre_humain()
        {
            static bool mch(true);
            return mch;
        }
        //---------------------------------------------------------------------------
        bool& donnees_strategies::mode_auto()
        {
            static bool maut(true);
            return maut;
        }
        //---------------------------------------------------------------------------
        // Constructeur
        donnees_strategies::donnees_strategies()
                {
                //fixe le nom des réponses
                noms_reps[a_leau]=wxT("A l'eau!");
                noms_reps[deja_touche]=wxT("déjà touché");
                noms_reps[inutile]=wxT("inutile");
                noms_reps[deja_joue]=wxT("déjà joué");
                noms_reps[touche]=wxT("Touché!");
                noms_reps[coule]=wxT("Coulé!");
                // fixe le nombre de bateaux de chaque longueur par défaut
                ajuste_flottille_a_grille();
                // fixe la forme par défaut des bateaux;
                fixe_forme_bateaux(lineaires);
                }
//---------------------------------------------------------------------------
// fin implémentation de la classe donnees_strategies
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
    donnees_strategies donnees; // crée une instance des données strategies disponible dans calcule
//---------------------------------------------------------------------------
        //---------------------------------------------------------------------------
        bateau construit_un_bateau_de_taille(bateau b,int taille_souhaite)
        {
        bateau resultat=b;
        bool trouve=(b.taille==taille_souhaite);// la fonction renverra b sans rien faire si b convient déjà
        plan_bateau pl=b.proprietaire->liste_voisins(&b,b.forme(),libre);
        if (pl.size()>0) // inutile de poursuivre s'il n'y a aucun voisin valide
            {
            for (unsigned int i=0;i<pl.size();i++)
            if(!trouve)
                {
                b.ajoute_case(pl[i]);
                resultat=construit_un_bateau_de_taille(b,taille_souhaite);
                trouve=(resultat.taille==taille_souhaite);
                b.supprime_case(pl[i]);
                }
            }
        return resultat;
        }
        //---------------------------------------------------------------------------
        plan_bateau construit(bateau* client)
        {
        Traducteur tr;
        int taille_souhaitee=client->taille;
        TErreur_batnav erreur(tr.trad(wxT("Impossible de construire le bateau")),&Machine1());
        bateau resultat, provb(client->proprietaire,0);;
        plan_bateau p=client->proprietaire->liste_cases_libres();
        bool trouve=false;
        for (unsigned int i=0;i<p.size();i++)
            {
                if (!trouve)
                {
                provb.ajoute_case(p[i]);
                resultat=construit_un_bateau_de_taille(provb,client->taille);
                trouve=(resultat.taille==taille_souhaitee);
                provb.supprime_case(p[i]);
                }
            }
        if (!trouve) throw erreur;
        for (int i=0;i<taille_souhaitee;i++) resultat.plan[i]->change_statut(occupee);
        return resultat.plan;
        }
        //---------------------------------------------------------------------------
        // retourne la structure de la flottille (nb de bateaux de chaque taille)
        std::vector<int> structure_flottille(Tflottille& f)
        {std::vector<int> resultat;
        resultat.resize(donnees.taille_max_admissible_bateaux);
        for (unsigned int i=0;i<f.size();i++) resultat[f[i].taille-1]++;
        return resultat;
        }
        //---------------------------------------------------------------------------
        // retourne un plan de bateau tronqué avec uniquement les cases
        // qui ont le plus grand nombre de cases voisines libres
        // le paramètre declic définit la fréquence avec laquelle la fonction ne fera rien
        // Garde également les cases marginales au plus grand nombre de voisins
        //
        plan_bateau cases_les_moins_entourees_de(bateau b)
        {
        int declic=PARAM_DECLIC; // 70 semble un bon compromis
        plan_bateau resultat;
        if (RandomRange_bis(0,100)>declic)
            resultat=b.plan;
            else
            {
            int tab_tailles[donnees.taille_max_tableau()];
            int nb_max(0),nb_max_marginale(0),nb_max_en_coin(0);
            bool au_bord,en_coin,au_milieu;
            for (unsigned int i=0;i<b.plan.size();i++)
                    {
                    plan_bateau pl;
                    bateau provb(b.proprietaire,0);
                    provb.ajoute_case(b.plan[i]);
                    pl=b.proprietaire->liste_voisins(&provb,par_les_sommets,libre);
                    int n=pl.size();
                    tab_tailles[i]=n;
                    en_coin=b.plan[i]->case_en_coin();
                    au_bord=(b.plan[i]->case_au_bord()&&(!en_coin));
                    au_milieu=(!(au_bord||en_coin));
                    if (en_coin) nb_max_en_coin=(nb_max_en_coin>n?nb_max_en_coin:n);
                    if (au_bord) nb_max_marginale=(nb_max_marginale>n?nb_max_marginale:n);
                    if (au_milieu) nb_max=(nb_max>n?nb_max:n);
                    }
            for (unsigned int i=0;i<b.plan.size();i++)
                    {
                    en_coin=b.plan[i]->case_en_coin();
                    au_bord=(b.plan[i]->case_au_bord()&&(!en_coin));
                    au_milieu=(!(au_bord||en_coin));
                    if (en_coin) {if (tab_tailles[i]==nb_max_en_coin)resultat.push_back(b.plan[i]);}
                    if (au_bord) {if (tab_tailles[i]==nb_max_marginale)resultat.push_back(b.plan[i]);}
                    if (au_milieu) {if (tab_tailles[i]==nb_max)resultat.push_back(b.plan[i]);}
                    }
            }
        return resultat;
        }
        //---------------------------------------------------------------------------
        // Retourne les cases pouvant accueillir un bateau de taille = à tbat
        // resultat pointe sur le tableau de j->adversaire alors que
        // resultat_prov pointe sur un tableau provisoire
        plan_bateau cases_possibles_avec_bateau_de_taille_tbat(TJoueur* j,int tbat)
        {
        TJeu prov_j(wxT("Sans nom"),libre);
        j->adversaire.clone(&prov_j);
        bateau  resultat(&j->adversaire.son_tableau,0),
                resultat_prov(&prov_j.son_tableau,0),
                trouve(&prov_j.son_tableau,tbat);
        bool en_cours(true);
        while (en_cours)
             try
                {
                trouve.plan=construit(&trouve);
                // la sortie se fait par l'exception TErreur émise par construit
                // si aucun bateau de taille tbat n'est trouvé
                resultat_prov+=trouve;
                prov_j.flottille.push_back(trouve);
                trouve.plan.clear();
                }
             catch(TErreur_batnav& T)
                {en_cours=false;
                }
        resultat_prov.clone(&resultat);
        // sortie si échec
        if (resultat.taille<tbat)
                {
                TErreur_batnav erreur(wxT("Impossible de caser ce bateau"));
                throw erreur;
                }
        // sortie si succès
        return brasse(cases_les_moins_entourees_de(resultat));
        }
        //---------------------------------------------------------------------------
        int taille_du_plus_grand_bateau_restant_a_trouver(TJoueur* j)
        {int resultat=0;
        std::vector<int> complet,en_cours;
        complet=structure_flottille(j->lui.flottille);
        en_cours=structure_flottille(j->adversaire.flottille);
        for (unsigned int i=0;i<complet.size();i++)
                      if (complet[i]-en_cours[i])resultat=i+1;
        return resultat;
        }
        //---------------------------------------------------------------------------
        //retourne un plan bateau avec les cases libres avec le plus de voisins possibles
        plan_bateau choisit_au_hasard(tableau* t)
        {Traducteur tr;
        TErreur_batnav erreur(tr.trad(wxT("Tricheur!"))+wxT(" ")+tr.trad(wxT("Il manque un bateau!")));
        bateau b(t,0);
        b.plan=t->liste_cases_libres();
        b.taille=b.plan.size();
        if (!b.plan.size()) throw erreur;
        return cases_les_moins_entourees_de(b);
        }
        //---------------------------------------------------------------------------
        //retourne false si la structure de la flottille est impossible
        bool flottille_possible(Tflottille& f)
        {int taille_max=0;
         // vérifie qu'il n'y a pas un bateau plus grand que la taille max
        for (unsigned int i=0;i<f.size();i++) if (f[i].taille>taille_max) taille_max=f[i].taille;
        bool reponse=taille_max>donnees.taille_max_bateau();

        // vérifie qu'il n'y a pas un bateau de plus par taille
        int taille_de[donnees.taille_max_admissible_bateaux];
        for (int i=0;i<donnees.taille_max_admissible_bateaux;i++) taille_de[i]=0;
        for (unsigned int i=0;i<f.size();i++) taille_de[f[i].taille-1]++;
        for (int i=0;i<donnees.taille_max_bateau();i++)
                reponse=( reponse||(taille_de[i]>donnees.structure_flottille_complete()[i]) );
        return !reponse;
        }
        //---------------------------------------------------------------------------
        //retourne false si la flottille est incomplète
        bool flottille_terminee(Tflottille& f)
        {
        bool reponse=true;
        int taille_de[donnees.taille_max_admissible_bateaux];
        for (int i=0;i<donnees.taille_max_admissible_bateaux;i++) taille_de[i]=0;
        for (unsigned int i=0;i<f.size();i++) taille_de[f[i].taille-1]++;
        for (int i=0;i<donnees.taille_max_bateau();i++)
                reponse=( reponse&&(taille_de[i]==donnees.structure_flottille_complete()[i]) );
        return reponse;
        }
        //---------------------------------------------------------------------------
        void simule_la_reponse_touchee(case_du_tableau* c,TJoueur* J)
        {
        case_du_tableau* ctab= &J->adversaire.son_tableau.contenu[c->abs()][c->ord()];
        if (J->memoire.bateau_repere)
                for (unsigned int i=0;i<J->adversaire.flottille.size();i++)
                        {
                        bateau b(&J->adversaire.son_tableau,0);
                        b.plan=J->adversaire.son_tableau.liste_voisins(&J->adversaire.flottille[i],b.forme(),libre);
                        b.taille=b.plan.size();
                        if (b.contient_case(*ctab))
                                J->adversaire.flottille[i].ajoute_case(ctab,touchee);
                        }
                else
                        {
                        bateau b1(&J->adversaire.son_tableau,0);
                        b1.ajoute_case(ctab,touchee);
                        J->adversaire.flottille.push_back(b1);
                        J->memoire.flottille_adversaire.push_back(b1);
                        }
        }
        //---------------------------------------------------------------------------
        // C'est ici que se fait le choix de la case à jouer.
        // Point de départ pour améliorer la qualité du jeu machine
        // retourne la case jouée par la machine, met à jour son tableau.
        // c'est le jeu "adversaire" (partiellement connu) qui est transmis ici
        // vérifie d'abord si la mémoire ne contient pas des cases à jouer en priorité.
        //---------------------------------------------------------------------------
        // Seconde étape ajuste à la personnalité de l'adversaire
        case_du_tableau case_adaptee_a_personnalite_adversaire(TJoueur* J,plan_bateau cases_possibles,bool vient_de_memoire)
        {
        TJoueur meilleur(wxT("meilleur"));
        TJoueur temporaire(wxT("temporaire"));
        TJoueur ancien(wxT("ancien"));
        J->clone(&meilleur);
        J->clone(&ancien);
        J->clone(&temporaire);
        // Si au moins un bateau de l'adversaire est connu
        // Augmente le poids de la grille courante par rapport à la personnalité passée
        if(J->memoire.flottille_adversaire.size()>1)
        {
            int renforcement=PARAM_RENFORCEMENT;// 4 semble convenir
            for (int i=0;i<renforcement;i++)
                        Scrutateur::met_a_jour_personnalite(&J->adversaire,true);
        }
        wxPoint cible=grille_favorite_de(temporaire.adversaire.personnalite);
        double distance=1000;
        double correction=0; // compilation en mode release refuse double correction=taille_grille_profiles()/(taille_grille_profiles()-1.0);
        correction=taille_grille_profiles()/(taille_grille_profiles()-1.0);
        case_du_tableau c;
        case_du_tableau resultat;
        unsigned int indice_meilleur=0;
        unsigned int nb_possibles=cases_possibles.size();
        for (unsigned int i=0;i<nb_possibles;i++)
            {
            J->clone(&temporaire);
            c= (*cases_possibles[i]);
            simule_la_reponse_touchee(&c,J);
            // ne prend en compte que l'aspect marginal pour moins de 3 bateaux
            double comp,cible_comp;
            if (J->memoire.flottille_adversaire.size()<3)
                    {comp=0;
                    cible_comp=0;
                    }
            else
                    {
                    comp=Scrutateur::compacite_flottille(&J->adversaire);
                    cible_comp=(cible.x*correction);
                    }
            vecteur position(comp,Scrutateur::marginalite_flottille(&J->adversaire));
            vecteur dist_vect(position.real()-cible_comp,position.imag()-(cible.y*correction));
            double distance_nouvelle=abs(dist_vect);
            if (distance_nouvelle<distance)
                    {
                    indice_meilleur=i;
                    temporaire.clone(&meilleur);
                    distance=distance_nouvelle;
                    resultat=c;
                    }
            ancien.clone(J);
            }
        if (vient_de_memoire) meilleur.memoire.reserve_de_cases_a_jouer.erase(meilleur.memoire.reserve_de_cases_a_jouer.begin()+indice_meilleur);
        meilleur.clone(J);
        return resultat;
        }
        //---------------------------------------------------------------------------
        // Première étape choisit une case qui fait bien
        case_du_tableau choisit_une_case_adaptee(TJoueur* J)
        {Traducteur tr;
        firstwin()->Dialogues->AppendText(J->nom+wxT(" ")+tr.trad(wxT("réfléchit"))+LF);
        bool vient_de_memoire(J->memoire.reserve_de_cases_a_jouer.size()>0);
        plan_bateau cases_possibles;
        try {
            if (vient_de_memoire)
                cases_possibles=J->memoire.reserve_de_cases_a_jouer;
                else
                {
                // cherche une case dans un espace pouvant cacher le plus grand bateau possible
                int tbat=taille_du_plus_grand_bateau_restant_a_trouver(J);
                if (tbat>1)
                    cases_possibles=cases_possibles_avec_bateau_de_taille_tbat(J,tbat);
                    else
                    cases_possibles=choisit_au_hasard(&J->adversaire.son_tableau);
                };
            }
         catch (TErreur_batnav& T)
            {
            T.client=J;
            throw;
            }
        return case_adaptee_a_personnalite_adversaire(J,cases_possibles,vient_de_memoire);
        }
}
//---------------------------------------------------------------------------
//      Fin namespace Strategies
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      namespace superviseur
//---------------------------------------------------------------------------
// Arbitre du jeu
// Règle le déroulement d'une partie
//  Pour une partie Machine contre humain
// joue_un_coup_machine_contre_humain --> bouton (touché coulé ...) --> traite_reponse
//          --> joue_un_coup_humain --> traite_reponse --> joue_un_coup_machine_contre_humain
//  Pour une partie Machine contre Machine
// joue_un_coup_machine_contre_machine --> joue_un_coup_machine_contre_machine --> ...
// La fin de partie est gérée par le superviseur qui surveille Strategies::flottille_terminee ou détecte un coup illégal
namespace superviseur
{
        bool coup_machine1=true; //indique qui a la main
        //---------------------------------------------------------------------------
        bool& partie_initialisee()//indique qu'une partie même non commencée a été initialisé
        {
            static bool pinit=false;
            return pinit;
        }
        //---------------------------------------------------------------------------
        bool& interruption_demandee()//indique que le bouton stop a été pressé.
        {
            static bool intdem=false;
            return intdem;
        }
        //---------------------------------------------------------------------------
        bool& partie_en_cours()//indique qu'une partie est lancée;
        {
            static bool penc=false;
            return penc;
        }
        //---------------------------------------------------------------------------
        void Creation_de_la_flottille(TJoueur* J)
        {
        int Nb_max_essais=10;

          for (int i=Strategies::donnees.taille_max_bateau();i>0;i--) //Commence par placer les plus grands bateaux
                {
                for (int j=0;j<Strategies::donnees.structure_flottille_complete()[i-1];j++) // Crée le nombre de bateaux recommandé
                    {
                    bateau bateau_en_chantier(&J->lui.son_tableau,i);
                    try {
                        bateau_en_chantier.plan=Strategies::construit(&bateau_en_chantier); // Renvoie une exception si échec
                        J->lui.flottille.push_back(bateau_en_chantier); //ajoute le bateau crée
                        J->lui.son_tableau.interdit_cases_autour_du_bateau(&bateau_en_chantier);
                        }
                        catch (TErreur_batnav& T) // cas où la création du bateau a échouée
                                {
                                j=Strategies::donnees.structure_flottille_complete()[i-1]; // provoquera la sortie de la boucle j
                                i=Strategies::donnees.taille_max_bateau()+1;// redémarre la construction de la flottille
                                J->coup_deponge();
                                if(!Nb_max_essais--) throw; // Jet de l'éponge, on n'y arrive pas
                                }
                    }
                }
        }
        //---------------------------------------------------------------------------
        void Creation_de_la_flottille_adaptee(TJoueur* J)
        {Traducteur tr;
        TJeu meilleur(wxT("meilleur"),libre);
        firstwin()->Dialogues->AppendText(LF+J->nom+wxT(" ")+tr.trad(wxT("flottille en construction"))+LF);
        double correction=0;
        // Compacité et marginalité retournent des valeurs entre 0 et taille_grille_profile
        // alors que la cible retourne des valeurs entre 0 et taille_grille_profile -1 (0 et 4 ici)
        // d'où le facteur de correction
        correction=taille_grille_profiles()/(taille_grille_profiles()-1.0);
        int nb_essais=1000; // nombre de tentatives maxi. Ne devrait jamais être atteint donc n'est pas un paramètre
        double precision_maxi=0.5;
        wxPoint cible=Strategies::grille_favorite_de(J->lui.personnalite);
        double distance=1000;
        for (int i=0;i<nb_essais;i++)
            {
            bool bypass=false;
            J->coup_deponge();
            if (!(i % 50)) wxGetApp().Yield(); // évite les freeze en vidant le tampon messages de Windows
            try {Creation_de_la_flottille(J);}
            catch (TErreur_batnav& T)
                {   // la création de la flottille a échouée
                bypass=true;
                if (i==(nb_essais-1)&&(distance==1000)) //aucune réussite en 1000 tentative
                    {firstwin()->Dialogues->AppendText(wxT("1000 essais "));// ne devrait jamais apparaître sauf avec une flottille incompatible avec la taille de la grille
                    throw;// provoquera un arrêt du programme sur erreur car l'exception n'est pas traitée ensuite
                    }
                }
            if(!bypass)
                {// la création ce la flottille a réussie
                vecteur position(Scrutateur::compacite_flottille(&J->lui),Scrutateur::marginalite_flottille(&J->lui));
                vecteur dist_vect(position.real()-cible.x*correction,position.imag()-cible.y*correction);
                double distance_nouvelle=abs(dist_vect);
                if (distance_nouvelle<distance)
                    {distance=distance_nouvelle;
                    J->lui.clone(&meilleur); // Si la flottille est meilleure elle est conservée
                    firstwin()->Dialogues->AppendText(wxString::Format(wxT("%2.2f"),distance)+wxT(" "));
                    }
                }
            if (distance<precision_maxi) // Evite de continuer si la distance est nulle et donc la flottille optimale
                i=nb_essais;
            }
        meilleur.clone(&J->lui); // renvoie la meilleure solution
        }
//---------------------------------------------------------------------------
        types_reponses reponse_machine(case_du_tableau c,TJoueur* j)
        {using namespace Strategies;
        types_reponses reponse=a_leau;
        TJoueur* J_adv=(j==(&Machine1())?&Machine2():&Machine1());
        case_du_tableau* case_jouee=&j->lui.son_tableau.contenu[c.abs()][c.ord()];
        case_du_tableau etat_connu= (*J_adv).adversaire.son_tableau.contenu[c.abs()][c.ord()];
        switch (case_jouee->lit_statut())
            {
            case occupee:
                {case_jouee->change_statut(touchee);
                bateau bateau_touche=j->lui.quel_bateau(c);
                if (bateau_touche.coule())
                        reponse=coule;
                        else reponse=touche;
                break;
                }
            case jouee      :return deja_joue;
            case touchee    :return deja_touche;
            case libre      :if (etat_connu.lit_statut()==interdite) return inutile;
            case interdite  :if (etat_connu.lit_statut()==interdite) return inutile;
            default         : case_jouee->change_statut(jouee);
            }
        return reponse;
        }
//---------------------------------------------------------------------------
        // renvoie faux si la flottille du joueur humain n'est pas prête.
        bool joueur_humain_cree_flottille()
        {Traducteur tr;
        wxString s;
        Machine2().lui.son_tableau.echiquier->enable_on_off(true);
        bool reponse=true;
        if (Strategies::flottille_terminee(Machine2().lui.flottille))
                {firstwin()->Dialogues->AppendText(tr.trad(wxT("flottille terminée, maintenant on joue"))+LF);
                firstwin()->Dialogues->AppendText(tr.trad(wxT("Bouton > pour lancer la partie"))+LF);
                Machine2().lui.son_tableau.echiquier->enable_on_off(false);
                }
                else
                {reponse=false;
                std::vector<int> nb_bat=Strategies::structure_flottille(Machine2().lui.flottille);
                firstwin()->Dialogues->AppendText(Machine2().nom+wxT(" ")+tr.trad(wxT("vous devez construire votre flottille"))+LF);
                firstwin()->Dialogues->AppendText(tr.trad(wxT("taille"))+wxT("   ")+tr.trad(wxT("nb actuel"))+wxT(" ")+tr.trad(wxT("attendus"))+LF);
                for (unsigned int i=0;i<Strategies::donnees.structure_flottille_complete().size();i++)
                        {
                        s=wxString::Format(wxT("%2i"),i+1)+TAB+wxString::Format(wxT("%2i"),nb_bat[i])+TAB+wxString::Format(wxT("%2i"),Strategies::donnees.structure_flottille_complete()[i]);
                        firstwin()->Dialogues->AppendText(s+LF);
                        }
                }
        return reponse;
        }
//------------------------------------------------------------------------
            void affecte_flottille(Tflottille& in,Tflottille& out)
            // out reçoit une copie de in
            {
                out.clear();
                size_t t=in.size();
                for (unsigned i=0;i<t;i++)
                out.push_back(in[i]);
            }
//---------------------------------------------------------------------------
        void ajoute_case_pointee(wxPoint position)
        // Ajoute une case pointée à la souris à la flottille du joueur humain (&Machine2())
        // Si la case est occupée, la supprime.
        // appelée à la suite d'un clic sur le tableau du joueur humain
        {Traducteur tr;
        TConseils conseils;
        bateau b,nouveau(&Machine2().lui.son_tableau,0);
        //variables conservant la situation avant modification
        Tflottille prov_f; // on va travailler sur une copie de Machine2().lui.flottille
        affecte_flottille(Machine2().lui.flottille,prov_f); // le compilateur en mode release refuse l'affectation directe prov_f=Machine2().lui.flottille
        liste_statuts ancien_statut;
        case_du_tableau* c=&Machine2().lui.son_tableau.contenu[position.x][position.y];
        ancien_statut=c->lit_statut();
        switch (c->lit_statut())
                {
                 case occupee:
                        {firstwin()->Dialogues->AppendText(tr.trad(wxT("Déjà occupée"))+LF);
                        int trouve=-1;
                        for (unsigned int i=0;i<prov_f.size();i++)
                                if (prov_f[i].contient_case(*c)) trouve=i;
                        if (trouve>-1)
                                {prov_f[trouve].supprime_case(c);
                                if (prov_f[trouve].taille==0)
                                        {
                                        std::vector<bateau>::iterator itb=prov_f.begin()+trouve;
                                        prov_f.erase(itb);
                                        }
                                }
                        };break;
                 case libre:
                        {bool convient=true;
                        // regarde si n'est pas dans les cases interdites de deux bateaux
                        // dans ce cas elle ne peut être ajoutée ni à l'un ni à l'autre
                        int nb_vois=0;
                        for (unsigned int i=0;i<prov_f.size();i++)
                                {
                                b.plan=Machine2().lui.son_tableau.liste_voisins(&prov_f[i],par_les_sommets,libre);
                                if(b.contient_case(*c))nb_vois++;
                                };
                        convient=(nb_vois<2); // faux si nb_vois>1
                        if (!convient)firstwin()->Dialogues->AppendText(tr.trad(wxT("Case interdite"))+LF);
                        // Si flottille non vierge regarde si appartient à un bateau existant
                        if (convient&&prov_f.size())
                           {
                           for (unsigned int i=0;i<prov_f.size();i++)
                                {
                                b.plan=Machine2().lui.son_tableau.liste_voisins(&prov_f[i],b.forme(),libre);
                                if (b.contient_case(*c))
                                        {prov_f[i].ajoute_case_occupee(c);convient=false;}
                                        // convient=false pour éviter d'ajouter à nouveau la case
                                }
                            }
                        // N'appartient à aucun bateau existant
                        // regarde si n'est pas dans les cases interdites d'un bateau existant
                        for (unsigned int i=0;i<prov_f.size();i++)
                                {
                                b.plan=Machine2().lui.son_tableau.liste_voisins(&prov_f[i],par_les_sommets,libre);
                                convient=convient&&(!b.contient_case(*c));
                                };
                        if (convient)
                                {
                                nouveau.ajoute_case_occupee(c);
                                prov_f.push_back(nouveau);
                                }
                        };break;
                        default:break;
                }
        if (Strategies::flottille_possible(prov_f))
                // si la flottille est possible, on garde les changements
                {affecte_flottille(prov_f,Machine2().lui.flottille);
                if (Strategies::flottille_terminee(prov_f))
                        {
                        for (unsigned int i=0;i<Machine2().lui.flottille.size();i++)
                        Machine2().lui.son_tableau.interdit_cases_autour_du_bateau(&Machine2().lui.flottille[i]);
                        }
                }
                else
                {
                c->change_statut(ancien_statut);
                wxMessageBox(conseils.suivant());
                }
        joueur_humain_cree_flottille();
        }
//---------------------------------------------------------------------------
        // traite le cas (rare) où deux cases non jointives d'un même bateau sont touchées successivement.
        // la procédure bateau_touche() créerait à tort deux bateaux nouveaux
        // conduisant à une erreur "tricheur" par la suite
        // met à jour la valeur de position_dans_flottille
        // L'appel récursif est nécessaire pour le cas (rare) où plus de deux cases touchées disjointes mais
        // appartenant au même bateau seraient en cause. En pratique avec un bateau  x4 option "fumette" disposé en étoile
        // et dont les cases périphériques sont touchées avant la case centrale
        // tordu mais nécessaire pour garder la possibilité de généraliser le jeu à de grandes grilles avec de très gros
        // bateaux où le cas deviendrait plus fréquent.
        bool agrege_des_bateaux_jointifs(TJoueur* jeu,int& position_dans_flottille)
        {Traducteur tr;
        static int profondeur_recursion=0; // donne la profondeur d'appel récursif de la procédure
        profondeur_recursion++;
        bool trouve_un=false;
        int pos=-1; //position du bateau coulé
        bateau voisins,b1,b=jeu->adversaire.flottille[position_dans_flottille];
        voisins.plan=
        jeu->adversaire.son_tableau.liste_voisins(&b,b.forme(),touchee);
        for (unsigned int i=0;i<jeu->adversaire.flottille.size();i++)
                if (int(i)!=position_dans_flottille)
                        {b1=jeu->adversaire.flottille[i];
                        for (unsigned int j=0;j<b1.plan.size();j++)
                                if (voisins.contient_case(*b1.plan[j]))
                                        {trouve_un=true;
                                        pos=i;
                                        }
                        }
        if (pos!=(-1))
                {
                firstwin()->Dialogues->AppendText(tr.trad(wxT("Navire fragmenté"))+LF);
                b1=jeu->adversaire.flottille[pos];
                for (unsigned int i=0;i<b1.plan.size();i++)
                jeu->adversaire.flottille[position_dans_flottille].ajoute_case(b1.plan[i],touchee);
                std::vector<bateau>::iterator itb;
                itb=jeu->adversaire.flottille.begin()+pos;
                jeu->adversaire.flottille.erase(itb);
                // corrige pour tenir compte du déplacement du bateau concerné en cas de suppression
                if (pos<position_dans_flottille) position_dans_flottille--;
                }
        if (trouve_un) agrege_des_bateaux_jointifs(jeu,position_dans_flottille);
        profondeur_recursion--;
        return trouve_un;
        }
//---------------------------------------------------------------------------
        // Regarde si un bateau annoncé comme touché existe bien
        // vérifie si le bateau ne dépasse pas la taille maxi sinon erreur "tricheur, bateau trop long"
        // Si le bateau est simplement touché (et non coulé) vérifie qu'il existe des cases jouables
        // met à jour la flottille
        wxString bateau_touche(TJoueur* j,case_du_tableau c,bool est_coule)
         {Traducteur tr;
         wxString message=wxT("RAS");
         TErreur_batnav erreur( tr.trad(wxT("Tricheur!"))+wxT(" ")+tr.trad(wxT("Ce bateau est trop long")),j );
         case_du_tableau* case_jouee= &j->adversaire.son_tableau.contenu[c.abs()][c.ord()];
         int position=j->adversaire.indice_du_bateau_incomplet(*case_jouee);
         if (position<0)
                        {
                        bateau b(&j->adversaire.son_tableau,0);
                        b.ajoute_case(case_jouee);
                        j->adversaire.flottille.push_back(b);
                        position=j->adversaire.flottille.size()-1;
                        }
                else    {j->adversaire.flottille[position].ajoute_case(case_jouee);
                        if (j->adversaire.flottille[position].taille>Strategies::donnees.taille_max_bateau()-(est_coule?0:1))
                                throw erreur; // si le bateau est simplement touché taill_max_bateau-1 est la taille à ne pas dépasser
                        }

         case_jouee->change_statut(touchee);
        // Attention agrège_des_bateaux_jointifs peut modifier la variable position
        agrege_des_bateaux_jointifs(j,position);
        //Met en mémoire les cases contiguës au bateau touché
         j->memoire.reserve_de_cases_a_jouer=j->adversaire.son_tableau.liste_voisins(&j->adversaire.flottille[position],Strategies::donnees.forme_bateaux(),libre);
         j->memoire.bateau_repere=true; // un bateau a été repéré
        // Aucune case jouable autour d'un bateau seulement touché : il y a un loup
        if (!est_coule&&(!j->memoire.reserve_de_cases_a_jouer.size()))
            {
            erreur.texte_erreur=tr.trad(wxT("Bien essayé !"));
            throw erreur;
            }
         return message;
         }
//---------------------------------------------------------------------------
        // Regarde si un bateau annoncé comme coulé existe bien sinon erreur "tricheur Ce bateau n'existe pas"
        // met à jour la flottille en mémoire des bateaux annoncés comme coulés
        // vérifie la cohérence de cette flottille sinon erreur "tricheur flottille impossible"
        // marque comme interdites les cases voisine du bateau coulé sur l'échiquier "adversaire"
        wxString bateau_coule(TJoueur* j,case_du_tableau c)
         { Traducteur tr;
         TErreur_batnav erreur(tr.trad(wxT("Tricheur!"))+wxT(" ")+tr.trad(wxT("Ce bateau n'existe pas")),j);
         nom_des_bateaux nbat;
         wxString message=bateau_touche(j,c,true); // Met à jour la case touchée, mettra aussi à jour la flottille de l'adversaire
         bateau b=j->adversaire.quel_bateau(c);
         if (b.taille==0) throw erreur; // ne devrait jamais se produire
         j->adversaire.son_tableau.interdit_cases_autour_du_bateau(&b);
         wxString s=nbat.nom_du(b.taille)+wxT(" ")+tr.trad(wxT("coulé"));
         firstwin()->Dialogues->AppendText(s+LF);
         // nettoie la réserve de cases à jouer en priorité
         j->memoire.reserve_de_cases_a_jouer.clear();
         j->memoire.bateau_repere=false;
         // met à jour la flottille connue de l'adversaire
         j->memoire.flottille_adversaire.push_back(b);
         if (!Strategies::flottille_possible(j->memoire.flottille_adversaire))throw erreur;
         return message;
         }
//---------------------------------------------------------------------------
        // la réponse est coup dans l'eau
        // met à jour le tableau "adversaire" du joueur actif
        // si un bateau était repéré et qu'il n'y a plus de case jouable, il y a tricherie
        wxString coup_dans_leau(TJoueur* j,case_du_tableau c)
         {Traducteur tr;
         wxString message=wxT("RAS");
         TErreur_batnav erreur(tr.trad(wxT("Tricheur!"))+wxT(" ")+tr.trad(wxT("Il y AVAIT quelque chose ici!")),j);
         if ( (j->memoire.reserve_de_cases_a_jouer.size()==0)&&(j->memoire.bateau_repere) )
                throw erreur;
         case_du_tableau* case_jouee= &j->adversaire.son_tableau.contenu[c.abs()][c.ord()];
         case_jouee->change_statut(jouee);
         return message;
         }
//---------------------------------------------------------------------------
        void active_boutons_reponse(bool activer)
        {
        // active les boutons touche coulé  à l'eau, inactive l'écran2 (choix de case à jouer)
        firstwin()->Boutaleau->Enable(activer);
        firstwin()->Boutouche->Enable(activer);
        firstwin()->Boutcoule->Enable(activer);
        Machine2().adversaire.son_tableau.echiquier->enable_on_off(!activer);
        }
//---------------------------------------------------------------------------
        void fin_de_partie(TJoueur* vainqueur)
        {Traducteur tr;
        // inactive les boutons de réponse et la grille adversaire
        active_boutons_reponse(false);
        Machine2().adversaire.son_tableau.echiquier->enable_on_off(false);
            // affiche un message de fin de partie
        wxString mes_res(vainqueur->nom+wxT(" ")+tr.trad(wxT("gagne")));
        firstwin()->Dialogues->AppendText(vainqueur->nom+LF);
        firstwin()->Dialogues->AppendText(vainqueur->nom+wxT(" ")+tr.trad(wxT("gagne"))+LF);
        partie_en_cours()=false;
        partie_initialisee()=false;
        if (!(Strategies::donnees.machine_contre_humain()||Strategies::donnees.mode_auto())) wxMessageBox(mes_res,tr.trad(wxT("Fin de partie")));
        Machine1().vide_memoire();
        Machine2().vide_memoire();
        bool mach1_vainqueur=(vainqueur->nom==Machine1().nom);
        Scrutateur::met_a_jour_personnalite(&Machine1().lui,mach1_vainqueur);
        Scrutateur::met_a_jour_personnalite(&Machine1().adversaire,!mach1_vainqueur);
        Scrutateur::met_a_jour_personnalite(&Machine2().lui,!mach1_vainqueur);
        Scrutateur::met_a_jour_personnalite(&Machine2().adversaire,mach1_vainqueur);
        met_a_jour_liste_joueurs();
        firstwin()->PersoJoueur->Refresh();
        firstwin()->item_menu_change=true;
        firstwin()->Refresh();
        // la fiche personnalité est affichée avec la personnalité de CMachine 2
        //PersoJoueur->recoit_valeurs(liste_joueur>s(),&Machine2());
        }
//---------------------------------------------------------------------------
        // joue_un coup est démembré en plusieurs modules qui s'enchaînent sans
        // interruption si le joueur est machine, mais qui sont attendent l'intervention
        // du joueur humain dans le cas contraire.
//---------------------------------------------------------------------------
        bool une_chance_sur_deux()
        {// retourne true une fois sur deux avec une probabilité 1/2
        return (RandomRange_bis(1,1001)>500);
        }
//---------------------------------------------------------------------------
        void prepare_joue_une_partie()
        {Traducteur tr;
        srand((unsigned)time(NULL));
        firstwin()->ChoixForme->Enable(false);
        firstwin()->ChoixTaille->Enable(false);
        firstwin()->Dialogues->Clear();
        firstwin()->Dialogues->AppendText(tr.trad(wxT("Nouvelle partie"))+LF);
            // Création du tableau du joueur Machine1
        Creation_de_la_flottille_adaptee(&Machine1());
        }
//---------------------------------------------------------------------------
        void traite_la_reponse(case_du_tableau c,TJoueur* j_passif,types_reponses reponse)
        {
        Traducteur tr;
        wxString message=wxT("RAS");
        TJoueur* j_actif=( j_passif==(&Machine2())?(&Machine1()):(&Machine2()) );
        //met à jour le bateau touché et en cascade le tableau
        firstwin()->Dialogues->AppendText(j_passif->nom+tr.trad(wxT(" répond:"))+Strategies::donnees.nom_reponse(reponse)+LF);
        try
        {
                switch (reponse)
                {
                case touche:                message=bateau_touche(j_actif,c,false);break;
                case coule:                 message=bateau_coule(j_actif,c);break;
                case deja_joue:             message=tr.trad(wxT("Nul! déjà jouée"));break;
                case deja_touche:           message=tr.trad(wxT("Nul! déjà jouée"));break;
                case inutile:{coup_dans_leau(j_actif,c);message=tr.trad(wxT("Un bien mauvais coup!"));break;}
                default: message=coup_dans_leau(j_actif,c);
                }
                firstwin()->Refresh();
                if (!(message==wxT("RAS"))) {wxMessageBox(message);firstwin()->Dialogues->AppendText(message+LF);}
                // Si la flottille est complète la partie est terminée
                if (Strategies::flottille_terminee(j_actif->adversaire.flottille)) fin_de_partie(j_actif);
        }
        catch (TErreur_batnav& err)
            { // La case jouée est impossible (seul le joueur humain fera cela). Il y a eu tricherie
            fin_de_partie(err.client);
            wxMessageBox(err.texte_erreur);
            }
        }
//---------------------------------------------------------------------------
        void joue_un_coup_machine_contre_humain()
        // choisit une case puis attend la réponse du joueur humain
        {Traducteur tr;
        try
        {
        TJoueur* j_actif;
        j_actif=&Machine1();
        case_du_tableau c;
        c=Strategies::choisit_une_case_adaptee(j_actif);
        Machine2().memoire.case_jouee=c;
//        firstwin()->Dialogues->AppendText(Machine1().nom+" "+tr.trad("a joué"))+" x="+FormatFloat("00",c.abs())+" y="+FormatFloat("00",c.ord()));
        firstwin()->Dialogues->AppendText(Machine1().nom+wxT(" ")+tr.trad(wxT("a joué"))+wxT(" ")+wxChar(int('a'+c.abs()))+wxT(" ")+wxChar(int('0'+c.ord()))+LF);
        active_boutons_reponse(true); // Redonne la main au joueur humain
        }
        catch (TErreur_batnav& err)
            { //Machine 1 n'a pas pu choisir une case licite. Donc le joueur a triché
            wxString Message(tr.trad(err.texte_erreur));
            wxMessageBox(Message);
            firstwin()->Dialogues->AppendText(Message+LF);
            fin_de_partie(err.client);
            }
        }
//---------------------------------------------------------------------------
        // lancé par le clic sur une case du tableau Ecran2
        void joue_un_coup_humain(case_du_tableau c)
        {Traducteur tr;
        TJoueur* j_passif;
        j_passif=&Machine1();
        traite_la_reponse(c,j_passif,reponse_machine(c,j_passif));
        if (partie_en_cours()) joue_un_coup_machine_contre_humain(); // Redonne la main à machine1
        }
//---------------------------------------------------------------------------
        bool joue_un_coup_machine_contre_machine(TJoueur* j_actif,TJoueur* j_passif)
        {// retourne true en fin de partie
        case_du_tableau c;
        c=Strategies::choisit_une_case_adaptee(j_actif);
        traite_la_reponse(c,j_passif,reponse_machine(c,j_passif));
        // Si la flottille est complète la partie est terminée
        return Strategies::flottille_terminee(j_actif->adversaire.flottille);
        }
//---------------------------------------------------------------------------
        // joue une partie dans le cas machine contre humain
        // ne sera atteint que si le jeu du joueur est complet et valide
        void joue_partie_machine_humain()
        {Traducteur tr;
        prepare_joue_une_partie();
        Machine1().adversaire.nom=Machine2().nom;
        firstwin()->Refresh();
            // choisit le premier à jouer
        coup_machine1=une_chance_sur_deux();
        if (coup_machine1) joue_un_coup_machine_contre_humain();
            else
            {
            firstwin()->Dialogues->AppendText(tr.trad(wxT("A vous de jouer "))+Machine2().nom+LF);
            active_boutons_reponse(false); // Donne la main au joueur humain pour son premier coup
            // Ensuite Joue_un_coup_humaine appellera Joue_un_coup_machine_contre_humain
            // Qui redonne la main au joueur humain et ainsi de de suite
            }
        }
//---------------------------------------------------------------------------
        void joue_une_partie_machine_machine()
        {Traducteur tr;
        using Strategies::donnees;
        wxGetApp().Yield();
        try
            {
            prepare_joue_une_partie();
            // Création du tableau du joueur Machine2
            Creation_de_la_flottille_adaptee(&Machine2());
            firstwin()->Refresh();
            // choisit le premier à jouer
            coup_machine1=une_chance_sur_deux();
            TJoueur* j_actif;
            TJoueur* j_passif;
            j_actif =(coup_machine1?&Machine1():&Machine2());
            j_passif=(coup_machine1?&Machine2():&Machine1());
           // Joue une partie
           // La fin de partie normale est actée par "joue_un_coup_machine_contre_machine"
            while(!joue_un_coup_machine_contre_machine(j_actif,j_passif)&&(!interruption_demandee()))
                {
                coup_machine1=!coup_machine1;
                j_actif =(coup_machine1?&Machine1():&Machine2());
                j_passif=(coup_machine1?&Machine2():&Machine1());
                wxGetApp().Yield();; // évite les freeze en vidant le tampon messages de Windows
                }
            if (interruption_demandee()) fin_de_partie(j_actif);
            //fin_de_partie(j_actif)
            }
        catch (TErreur_batnav& err)
            {
            fin_de_partie(err.client);
            };
         }
        //---------------------------------------------------------------------------
        // reçoit la réponse du joueur humain après la pression sur un bouton
        // Traite la réponse et l'affiche
        // Prépare les boutons pour le coup humain suivant
        // la réponse concerne le bateau (touché coulé) le statut est celui de la case (touchée si le bateau est coulé)
        void humain_donne_reponse(types_reponses reponse,liste_statuts statut)
        {Traducteur tr;
        case_du_tableau c=Machine2().memoire.case_jouee;
        Machine2().lui.son_tableau.contenu[c.abs()][c.ord()].change_statut(statut);
        traite_la_reponse(c,&Machine2(),reponse);
        if (partie_en_cours())
            {
            firstwin()->Dialogues->AppendText(tr.trad(wxT("A vous de jouer "))+Machine2().nom+LF);
            active_boutons_reponse(false);
            }
        }
        //---------------------------------------------------------------------------
        bool met_a_jour_liste_joueurs()
        {
        // met à jour la liste des personnalités
        // Un joueur a deux personnalité chacune nommée (lui adversaire)
        // Seule celle de "lui"
        // est sauvegardée dans liste_joueur sous le nom du joueur.
        int correct=0;
        int indice=liste_joueurs().index_de(Machine1().nom);
        if (indice>=0)
            {
            correct+=1;
            liste_joueurs()[indice]=Machine1().lui.personnalite;
            liste_joueurs()[indice].formate_nom(Machine1().nom);
            }
        //idem pour Machine2
        indice=liste_joueurs().index_de(Machine2().nom);
        if (indice>=0)
            {
            correct+=1;
            liste_joueurs()[indice].formate_nom(Machine2().nom);
            liste_joueurs()[indice]=Machine2().lui.personnalite;
            }
        return (correct==2);
        }
        //---------------------------------------------------------------------------
        // Fonction non utilisée normalement mais servant à étalonner
        // les abaques de du vecteur qualite_grille
        // Machine1 est utilisé comme grille de test
/*        void statistiques_comp_marg()
        {
        int resultat[3][3][5][5];
        for (int i=0;i<3;i++)
                for (int j=0;j<3;j++)
                        for (int k=0;k<5;k++)
                                for (int l=0;l<5;l++)
                                        resultat[i][j][k][l]=0;
        int nb_essais=1000;

        // met de côté la situation initiale
        int taille_ech_anc=Form1->ChoixTaille->ItemIndex;
        bateau b;
        types_de_bateaux forme_anc=b.forme();
        // reconstitue la situation initial
        b.forme()=forme_anc;
        for (int taille=0;taille<3;taille++)
                {
                Form1->ChoixTaille->ItemIndex=taille;
                for(int forme=0;forme<3;forme++)
                        {
                        b.forme()=types_de_bateaux(forme);
                        Strategies::donnees.ajuste_flottille_a_grille();
                        for (int i=0;i<nb_essais;i++)
                                {
                                Creation_de_la_flottille(&Machine1());
                                resultat[taille][forme][Scrutateur::compacite_flottille(&Machine1().lui)]
                                                       [Scrutateur::marginalite_flottille(&Machine1().lui)]++;
                                Machine1().coup_deponge();
                                }
                        }
                }
        Form1->ChoixTaille->ItemIndex=taille_ech_anc;
        Form1->Dialogues->Lines->Clear();
        for (int i=0;i<3;i++)
                {firstwin()->Dialogues->AppendText("Largeur"+FormatFloat("0",i));
                for (int j=0;j<3;j++)
                     {firstwin()->Dialogues->AppendText("Forme"+FormatFloat("0",j));
                        for (int k=0;k<5;k++)
                             {firstwin()->Dialogues->AppendText("Compacité"+FormatFloat("0",k));
                             wxString L;
                             for (int l=0;l<5;l++)
                                        L+=FormatFloat("000",resultat[i][j][k][l])+",";
                             firstwin()->Dialogues->AppendText(L);
                             }
                     }
                }

        }
*/
}
//---------------------------------------------------------------------------
//      Fin classe superviseur
//---------------------------------------------------------------------------
