#ifndef CALCULE_H_INCLUDED
#define CALCULE_H_INCLUDED
/*
    Batanav est un jeu de bataille navale très classique.
    Copyright (C) 2005 - 2009-2020 Vial Jean-Luc Annecy
    Contact email: vial.frjl@free.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <wx/wx.h>
#include "ProjetdeBase.h"

void test_listejoueur(Tliste_joueurs j);
//---------------------------------------------------------------------------
    namespace Scrutateur
{
    double fignole (double v);
    double ajuste_profile(int taille,int forme,bool compacite,double valeur);
    double nb_cases_interdites_maxi(int n,int m);
    double nb_cases_interdites_mini(int n,int m);
    double Nb_cases_interdites_mini_flottille(Tflottille& f);
    double Nb_cases_interdites_maxi_flottille(Tflottille& f);
    int nb_cases_interdites_effectif(TJeu* j);
    double compacite_flottille(TJeu* j);
    double marginalite_flottille(TJeu* j);
    bool met_a_jour_personnalite(TJeu* j,bool vainqueur);
};
//---------------------------------------------------------------------------
    typedef enum {a_leau,deja_touche,inutile,deja_joue,touche,coule} types_reponses;
//---------------------------------------------------------------------------
    namespace Strategies
{
    class donnees_strategies
        {
        std::map<types_reponses,wxString> noms_reps;
        public:
        std::vector<int>& structure_flottille_complete();
        // taille du bateau le plus grand géré par le programme
        int& taille_max_bateau();
        // limite du paramétrage
        static const int taille_max_admissible_bateaux=PARAM_TAILLE_MAX_ADMISSIBLE_BATEAUX; // 10 dans  cette version
        static const int taille_max_admissible_grille=PARAM_TAILLE_MAX_ADMISSIBLE_GRILLE; // 12 dans cette version
        bool& machine_contre_humain();
        bool& mode_auto();
        int taille_max_tableau();
        void fixe_structure_flottille(int t1,int t2,int t3,int t4);
        void ajuste_flottille_a_grille();
        wxString nom_reponse(types_reponses rep);
        types_de_bateaux forme_bateaux();
        void fixe_forme_bateaux(types_de_bateaux typ);
        donnees_strategies();
        };

    wxPoint grille_favorite_de(Tpersonnalite p);
    plan_bateau construit(bateau* client);
    std::vector<int> structure_flottille(Tflottille& f);
    plan_bateau cases_les_moins_entourees_de(bateau b);
    plan_bateau cases_possibles_avec_bateau_de_taille_tbat(TJoueur* j,int tbat);
    int taille_du_plus_grand_bateau_restant_a_trouver(TJoueur* j);
    plan_bateau choisit_au_hasard(tableau* t);
    bool flottille_possible(Tflottille& f);
    bool flottille_terminee(Tflottille& f);
    void simule_la_reponse_touchee(case_du_tableau* c,TJoueur* J);
    case_du_tableau choisit_une_case_adaptee(TJoueur* J);
};
//---------------------------------------------------------------------------
    namespace superviseur
{
    bool& partie_initialisee();//indique qu'une partie même non commencée a été initialisé
    bool& interruption_demandee();//indique que le bouton stop a été pressé.
    bool& partie_en_cours();//indique qu'une partie est lancée;
    //---------------------------------------------------------------------------

    void Creation_de_la_flottille(TJoueur* J);
    void Creation_de_la_flottille_adaptee(TJoueur* J);
    types_reponses reponse_machine(case_du_tableau c,TJoueur* j);
    bool joueur_humain_cree_flottille();
    void ajoute_case_pointee(wxPoint position);
    bool agrege_des_bateaux_jointifs(TJoueur* j,int& position_dans_flottille);
    wxString bateau_touche(TJoueur* j,case_du_tableau c,bool est_coule);
    wxString bateau_coule(TJoueur* j,case_du_tableau c);
    wxString coup_dans_leau(TJoueur* j,case_du_tableau c);
    void active_boutons_reponse(bool activer);
    void fin_de_partie(TJoueur* vainqueur);
    bool une_chance_sur_deux();
    void prepare_joue_une_partie();
    void traite_la_reponse(case_du_tableau c,TJoueur* j_passif,types_reponses reponse);
    void joue_un_coup_machine_contre_humain();
    void joue_un_coup_humain(case_du_tableau c);
    bool joue_un_coup_machine_contre_machine(TJoueur* j_actif,TJoueur* j_passif);
    void joue_partie_machine_humain();
    void joue_une_partie_machine_machine();
    void humain_donne_reponse(types_reponses reponse,liste_statuts statut);
    bool met_a_jour_liste_joueurs();
};

#endif //CALCULE_H_INCLUDED
