#ifndef DESSIN_H_INCLUDED
#define DESSIN_H_INCLUDED
/*
Batanav est un jeu de bataille navale très classique.
Copyright (C) 2005 - 2009-2020 Vial Jean-Luc Annecy
Contact email: vial.frjl@free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <wx/wx.h>

class case_du_tableau;
class Tpersonnalite;

//---------------------------------------------------------------------------
class   Tgraphique: public wxWindow
{
        wxPoint fait_absXY(const vecteur& valeur);   // convertit les coordonnées écran virtuel en coordonnées pixels de la paintbox
        vecteur fait_virtXY(const wxPoint& valeur); // convertit les coordonnées écran réel en coordonnées virtuelles
        wxPoint fait_abs_dans_margeXY(vecteur valeur);
        void fixe_parametres(int nb);
        double cote_case() const;
        wxColor couleur_de(float valeur);
        void trace_carre(const vecteur& position,double cote,wxColour couleur,wxDC& dc);
        void trace_rectangle(const vecteur& position_centre,const vecteur& diagonale,wxColour couleur,wxDC& dc);
        void trace_rectangle_incline(const vecteur& position_centre,const vecteur& diagonale,wxColour couleur,double angle_rad,wxDC& dc);
        void trace_triangle(const vecteur& position,const double& cote,wxColour couleur,int quartier,wxDC& dc);
        void trace_case_relief(const vecteur& position,double cote,int epaisseur,wxColour fond,wxColour b_ombre,wxColour B_lum,bool relief,wxDC& dc);
        void trace_case_bateau(const vecteur& position,liste_statuts touche_coule,wxDC& dc);
        void trace_case_bateau_occupee(const vecteur& position,wxDC& dc);
        void trace_case_bateau_touche(const vecteur& position,wxDC& dc);
        void trace_case_vide(const vecteur& position,wxDC& dc);
        void trace_case_interdite(const vecteur& position,wxDC& dc);
        void trace_case_jouee(const vecteur& position,wxDC& dc);
        void trace_case_inconnue(const vecteur& position,wxDC& dc);
        void guirlande(bool verticale,wxDC& dc);
public:
        struct {
                type_contenu* ech_contenu; // type_contenu pour joueurs
                Tpersonnalite* pers_contenu; // contenu pour personnalité
                bool est_machine1; // vrai si machine 1, sinon machine2
                bool est_lui;       // vrai si lui sinon adversaire
                bool est_perso;     // vrai si personnalité sinon machine
                int nb_cases;
                bool guirlande_active,echiquier_actif,echiquier_visible;
                wxPoint pixels; // Nombre de pixels du canvas virtuel
                int largeur_bord_echiquier,largeur_marge,largeur_bord_case;
                wxColour bord_ombre, bord_eclaire,fond_echiquier,
                       bord_case_ombre,bord_case_eclairee,fond_case,
                       marque_interdite,marque_jouee,inconnue,lignes;
                } parametres_internes;
        void enable_on_off(bool ech_on);
        void guirlande_on_off(bool gui_on);
        void visible_on_off(bool vis_on);
        wxPoint case_pointee(wxPoint position_souris);
        void trace_echiquier(wxDC& dc);
        void trace_case(const case_du_tableau& c,wxDC& dc);
        void trace_case_couleur(int x,int y,wxColour c,wxDC& dc);
        void trace_tout(wxDC& dc);
        // Canvas pour échiquier de jeu
        //Tgraphique(wxWindow* parent,wxWindowID id,wxPoint pos,wxSize taille,int nombre_de_cases,type_contenu* cont,wxString tip);
        Tgraphique(wxWindow* parent,wxWindowID id,wxPoint pos,wxSize taille,int nombre_de_cases,wxString tip);
        //Canvas pour affichage personnalités
        Tgraphique(wxWindow* parent,wxWindowID id,wxPoint pos,wxSize taille,int nombre_de_cases,Tpersonnalite* cont,wxString tip);
        void teste_graphique(wxDC& dc);
        void resize();
        void OnPaint (wxPaintEvent& WXUNUSED(event));
        void OnButton1(wxMouseEvent& event);
        DECLARE_EVENT_TABLE()
};

#endif // DESSIN_H_INCLUDED
