#include "FichePersoJoueur.h"
#include "Calcule.h"
#include <wx/button.h>
#include "../Icones/batanav16.xpm"

//---------------------------------------------------------------------------

const long FichePerso::idBoutonPurgePerso = wxNewId();
const long FichePerso::idBoutonSupprime = wxNewId();
const long FichePerso::idCanvas5= wxNewId();
const long FichePerso::idCanvas6= wxNewId();
const long FichePerso::idLabCompac= wxNewId();
const long FichePerso::idLabMargin= wxNewId();
const long FichePerso::idLabScore= wxNewId();
const long FichePerso::idChoixPerso= wxNewId();

BEGIN_EVENT_TABLE(FichePerso, wxFrame)
    EVT_PAINT(FichePerso::OnPaint)
    EVT_BUTTON(idBoutonPurgePerso,FichePerso::OnBoutonPurgePerso)
    EVT_BUTTON(idBoutonSupprime,FichePerso::OnBoutonSupprime)
    EVT_CLOSE(FichePerso::OnQuit1)
    EVT_COMBOBOX(idChoixPerso, FichePerso::OnChoixPerso)
    EVT_TEXT_ENTER(idChoixPerso, FichePerso::OnChoixPersoTexte)
END_EVENT_TABLE()

//---------------------------------------------------------------------------
// Constructeur
//---------------------------------------------------------------------------

FichePerso::FichePerso(wxWindow* parent,wxWindowID idficheperso,Tpersonnalite* perso1,Tpersonnalite* perso2):wxFrame(parent,idficheperso,wxT("Personnalité"),
                wxPoint(300,100),wxSize(100,100),wxFULL_REPAINT_ON_RESIZE|wxDEFAULT_FRAME_STYLE)

{
    FixeFontEtTaille(this);
    // Liste des personnalités
    wxString Choices[1];//Nécessaire avec le constructeur plus complet exigé par l'option wxTE_PROCESS_ENTER
    ChoixPerso=new wxComboBox(this,idChoixPerso,wxT(""),wxPoint(5,5),wxSize(190,25),0,Choices,wxTE_PROCESS_ENTER);
    Met_a_jour_ChoixPerso();
    // Affichage des échiquier de personnalités
    TTableau_personnalite* abaque1=new TTableau_personnalite();
    TTableau_personnalite* abaque2=new TTableau_personnalite();
    Canvas5= new Tgraphique(this,idCanvas5,wxPoint(100,100),wxSize(100,100),5,perso2,wxT("Type de grille préféré par le joueur"));
    abaque1->echiquier=Canvas5;
    abaque1->prepare_ecran(false,true);
    Canvas6= new Tgraphique(this,idCanvas6,wxPoint(100,100),wxSize(100,100),5,perso1,wxT("Type de grille de l'adversaire"));
    abaque2->echiquier=Canvas6;
    abaque2->prepare_ecran(true,true);
    // Labels
    LabScore=new wxStaticText(this,idLabScore,wxT("Score"),wxPoint(40,40),wxSize(40,10));
    LabCompac=new wxStaticText(this,idLabCompac,wxT("0<-- X jeu compact -->4"),wxPoint(40,60),wxSize(10,10));
    LabMargin=new wxStaticText(this,idLabMargin,wxT("Y Marginal"),wxPoint(40,60),wxSize(10,10));
    // Boutons
    BoutonPurgePerso=new wxButton(this,idBoutonPurgePerso,wxT("Efface personnalité"),wxPoint(8,35),wxSize(10,10));
    BoutonSupprime=new wxButton(this,idBoutonSupprime,wxT("Supprime le joueur"),wxPoint(8,35),wxSize(10,10));
    SetBackgroundColour(Couleur_Fenetres_defaut());
    largeurFP=200; // largeur en pixel par défaut
    wxRect Pos=Taille_Fenetres_defaut();
    Pos.SetX(Pos.GetX()-largeurFP);
    Pos.SetY(Pos.GetY());
    Pos.SetWidth(largeurFP);
    SetSize(Pos);
    SetIcon(batanav16_xpm);
}
//---------------------------------------------------------------------------
FichePerso::~FichePerso()
{
}
//---------------------------------------------------------------------------
void FichePerso::Met_a_jour_ChoixPerso()
{
    // Mets à jour la combobox Choix perso en excluant Machine1
    // La personnalité de Machine 1 est de toutes façons affichée sur l'echiquier du bas
    ChoixPerso->Clear();
    if (liste_joueurs().size()<2) affiche_message(wxT("Liste vide"));
        else
        {
        for (unsigned int i=1;i<liste_joueurs().size();i++)
            ChoixPerso->Append(liste_joueurs()[i].extrait_nom());
        ChoixPerso->SetSelection(liste_joueurs().index_de(Machine2().nom)-1);
        }
}
//---------------------------------------------------------------------------
void FichePerso::rafraichit()
{
    Traducteur tr;
    wxPoint pos;
    wxSize taille;
    // Fixe la  taille des échiquiers
    pos=FaitReelle_Pos(wxPoint(100,180),this);
    taille=FaitReelle_Taille(wxSize(800,345),this);
    Canvas5->SetSize(wxRect(pos,taille));
    pos=FaitReelle_Pos(wxPoint(100,550),this);
    Canvas6->SetSize(wxRect(pos,taille));
    // Retrace les boutons
    pos=FaitReelle_Pos(wxPoint(50,895),this);
    taille=FaitReelle_Taille(wxSize(900,50),this);
    BoutonPurgePerso->SetSize(wxRect(pos,taille));
    pos=FaitReelle_Pos(wxPoint(50,950),this);
    BoutonSupprime->SetSize(wxRect(pos,taille));
    // Retrace les labels
    wxString LabelScore(wxT("score=")+wxString::Format(wxT("%4i"),Machine2().lui.personnalite.victoires)+wxT("/")+wxString::Format(wxT("%3i"),Machine2().lui.personnalite.age));
    if((LabScore->GetLabel())!=LabelScore) LabScore->SetLabel(LabelScore);
    pos=FaitReelle_Pos(wxPoint(100,100),this);
    taille=FaitReelle_Taille(wxSize(800,50),this);
    LabScore->SetSize(wxRect(pos,taille));
    pos=FaitReelle_Pos(wxPoint(100,150),this);
    LabCompac->SetSize(wxRect(pos,taille));
    pos=FaitReelle_Pos(wxPoint(100,525),this);
    LabMargin->SetSize(wxRect(pos,taille));
}
//---------------------------------------------------------------------------
void FichePerso::OnBoutonPurgePerso(wxCommandEvent& event)
{
    Machine1().lui.personnalite.purge();
    Machine1().adversaire.personnalite.purge();
    Machine2().lui.personnalite.purge();
    Machine2().adversaire.personnalite.purge();
    superviseur::met_a_jour_liste_joueurs();
    Refresh();
};
//---------------------------------------------------------------------------
void FichePerso::OnBoutonSupprime(wxCommandEvent& event)
{
    Traducteur tr;
    int val_index=ChoixPerso->GetSelection()+1; // Choix perso reflète liste_joueurs moins le premier item: machine1 d'où le +1
    if (Machine2().nom==liste_joueurs()[val_index].extrait_nom())
        {
        if (liste_joueurs().size()>2)
            {
            liste_joueurs().erase(val_index);
            Machine2().nom=liste_joueurs()[1].extrait_nom();
            Machine2().lui.coup_deponge(libre);
            Machine2().lui.personnalite=liste_joueurs()[1];
            Met_a_jour_ChoixPerso();
            affiche_message(tr.trad(wxT("Bienvenue"))+wxT(" ")+Machine2().nom);
            if (IsShown()) Refresh();
            }
        else
            affiche_message(tr.trad(wxT("Il faut quand même  deux joueurs !")));
        }
};
//---------------------------------------------------------------------------
void FichePerso::OnQuit1(wxCloseEvent& event)
{
        Hide();
};
//---------------------------------------------------------------------------
void FichePerso::OnPaint(wxPaintEvent& event)
{
    wxPaintDC dc(this);
    rafraichit();
};
//---------------------------------------------------------------------------
void FichePerso::OnChoixPerso(wxCommandEvent& event)
{
    Traducteur tr;
    int val_index=ChoixPerso->GetSelection()+1; // Choix perso reflète liste_joueurs moins le premier item: machine1 d'où le +1
    if (Machine2().nom!=liste_joueurs()[val_index].extrait_nom())
        {
        Machine2().nom=liste_joueurs()[val_index].extrait_nom();
        Machine2().lui.coup_deponge(libre);
        Machine2().lui.personnalite=liste_joueurs()[val_index];
        affiche_message(tr.trad(wxT("Bienvenue"))+wxT(" ")+Machine2().nom);
        if (IsShown()) Refresh();
        }
}
//---------------------------------------------------------------------------
void FichePerso::OnChoixPersoTexte(wxCommandEvent& event)
{
    wxString nouveau_nom=ChoixPerso->GetValue();
    if (!liste_joueurs().contient(nouveau_nom))
        liste_joueurs().push_back(Tpersonnalite(nouveau_nom));
    Met_a_jour_ChoixPerso();
}
//-------------------------------------------------------------------------
