#include "ProjetdeBase.h"
#include "Dessin.h"
#include "APropos.h"
#include "Calcule.h"
#include "FichePersoJoueur.h"
#include "../Icones/batanav16.xpm"
#include "../Icones/sortie16.xpm"
#include "../Icones/files16.xpm"
#include "../Icones/go16.xpm"
#include "../Icones/delete16.xpm"
#include "../Icones/fr16.xpm"
#include "../Icones/eng16.xpm"
#include "../Icones/es16.xpm"
#include "../Icones/chapeau16.xpm"
#include "../Icones/help16.xpm"
#include "../Icones/save16.xpm"
#include <wx/file.h>
#include <wx/filename.h>
#include <wx/stdpaths.h>
#include <algorithm>
#include <wx/splash.h>
#include "wx/filesys.h"
#include "wx/fs_zip.h"

//---------------------------------------------------------------------------
//Variables utilisées pour tests
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// fonctions globales
//---------------------------------------------------------------------------
void affiche_message(wxString li)
{
    firstwin()->Dialogues->AppendText(li+LF);
}
//---------------------------------------------------------------------------
// variables globales
//---------------------------------------------------------------------------
// à travers les membres static de données_strategie
    Strategies::donnees_strategies donneesStrat;
//---------------------------------------------------------------------------
MainFrame*& firstwin()
{
    static MainFrame* fen=0;
    return fen;
}
//---------------------------------------------------------------------------
int& taille_echiquier_courant()
{
    static int taille=10;
    return taille;
}
//---------------------------------------------------------------------------
// Taille des grilles des profiles
int taille_grille_profiles()
    {static int taille=PARAM_TAILLE_GRILLE_PROFILES; //5 Dans cette version
    return taille;
    }
//---------------------------------------------------------------------------
//      Implémentation de l'objet TErreur_batnav
//---------------------------------------------------------------------------
        // type "lancé" en cas d'erreur
        TErreur_batnav::TErreur_batnav():texte_erreur(wxT("Erreur")),client(0){}
        TErreur_batnav::TErreur_batnav(wxString tex_er):texte_erreur(tex_er),client(0){}
        TErreur_batnav::TErreur_batnav(wxString tex_er,TJoueur* j):texte_erreur(tex_er),client(j){}

//---------------------------------------------------------------------------
//      Fin TErreur_batnav
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Implémentation Objet conseils
//---------------------------------------------------------------------------
         TConseils::TConseils()
                {
                Traducteur tr;
                items.push_back(tr.trad(wxT("Il est plus facile de construire la flottille des grands vers les petits bateaux")));
                items.push_back(tr.trad(wxT("Un second clic sur une case la supprime")));
                items.push_back(tr.trad(wxT("La structure attendue est récapitulée ci-contre")));
                Nombre_de_conseils=items.size();
                }
        //---------------------------------------------------------------------------
        wxString TConseils::suivant()
                {
                static int courant=-1;
                courant= (courant++ >(Nombre_de_conseils-2)?0:courant);
                return items[courant];
                }
//---------------------------------------------------------------------------
//      Fin Objet conseils
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//      Implémentation classe nom_des_bateaux
//---------------------------------------------------------------------------
        nom_des_bateaux::nom_des_bateaux()
                {
                items.push_back(wxT("Vedette"));
                items.push_back(wxT("Escorteur"));
                items.push_back(wxT("Destroyer"));
                items.push_back(wxT("Cuirassé"));
                items.push_back(wxT("Porte avions"));
                }
//---------------------------------------------------------------------------
        int nom_des_bateaux::longeur(wxString n)
                {int l=0;
                for (int i=0;i<int(sizeof(items));i++)
                     if (items[i]==n) l=i+1;
                return l;
                }
//---------------------------------------------------------------------------
        wxString nom_des_bateaux::nom_du(int lon)
                {Traducteur tr;
                wxString reponse;
                if ((lon<1)||(lon>int(items.size())))
                        reponse=wxT("Inconnu");
                        else reponse=items[lon-1];
                return tr.trad(reponse);
                }
//---------------------------------------------------------------------------
//      Fin de l'objet nom_des_bateaux
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Objet nom_des_formes
//---------------------------------------------------------------------------
        class nom_des_formes
        {
        std::map<types_de_bateaux,wxString> items;
        public:
        nom_des_formes()
                {
                items[lineaires]=wxT("traditionnelle");
                items[tordus]=wxT("tordue");
                items[par_les_sommets]=wxT("libre");
                }
//---------------------------------------------------------------------------
        wxString nom_de(types_de_bateaux typ)
                {Traducteur tr;
                return tr.trad(items[typ]);
                }
        };
//---------------------------------------------------------------------------
//      Fin de l'objet nom_des_formes
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//      Implémentation de l'objet case_du_tableau
//---------------------------------------------------------------------------
        case_du_tableau::case_du_tableau()
        {
        proprietaire=0;
        statut=inconnue;
        ord_val=0;
        abs_val=0;
        }
//---------------------------------------------------------------------------
        case_du_tableau::case_du_tableau(int x, int y,liste_statuts s,tableau* tableau_concerne)
        {
        proprietaire= tableau_concerne;
        int L=tableau_concerne->largeur_tableau();
        int H=tableau_concerne->hauteur_tableau();
        if (x>L) x=L;
        if (x<0) x=0;
        if (y>H) y=H;
        if (y<0) y=0;
        ord_val=y;
        abs_val=x;
        statut=s;
        }
//---------------------------------------------------------------------------
        void case_du_tableau::change_statut(liste_statuts nouveau)
        {
        statut=nouveau;
        }
//---------------------------------------------------------------------------
        liste_statuts case_du_tableau::lit_statut() const
        {
        return statut;
        }
//---------------------------------------------------------------------------
        int case_du_tableau::abs() const
        {
        return abs_val;
        }
//---------------------------------------------------------------------------
        int case_du_tableau::ord() const
        {
        return ord_val;
        }
//---------------------------------------------------------------------------
        bool case_du_tableau::case_en_coin()
        {int lar=proprietaire->largeur_tableau()-1;
        int h=proprietaire->hauteur_tableau()-1;
        bool reponse=((abs_val==0)||(abs_val==lar))&&((ord_val==0)||(ord_val==h));
        return reponse;
        }
//---------------------------------------------------------------------------
        bool case_du_tableau::case_au_bord()
        {int lar=proprietaire->largeur_tableau()-1;
        int h=proprietaire->hauteur_tableau()-1;
        bool reponse=((abs_val==0)||(abs_val==lar))||((ord_val==0)||(ord_val==h));
        return reponse;
        }
//---------------------------------------------------------------------------
        bool case_du_tableau::memes_coordonnees(case_du_tableau c)
        {
        return (abs()==c.abs())&&(ord()==c.ord());
        }
//---------------------------------------------------------------------------
        void case_du_tableau::clone(case_du_tableau* case_nouvelle)
        // recopie les données de façon valide dans une nouvelle case équivalente
        {
        case_nouvelle->abs_val=abs_val;
        case_nouvelle->ord_val=ord_val;
        case_nouvelle->statut=statut;
        }
//---------------------------------------------------------------------------
//      Fin de l'objet case_du_tableau
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//      Implémentation de l'objet tableau
//---------------------------------------------------------------------------
        //---------------------------------------------------------------------------
        bool tableau::ecran_actif()
        {
        return echiquier->parametres_internes.echiquier_actif;
        }
        //---------------------------------------------------------------------------

        plan_bateau tableau::liste_cases_libres()
        {// retourne une liste brassée des cases libres
        plan_bateau resultat;
        int L=largeur_tableau();
        int H=hauteur_tableau();
        for (int x=0;x<L;x++)
                for (int y=0;y<H;y++)
                        if (contenu[x][y].lit_statut()==libre) resultat.push_back(&contenu[x][y]);
        return brasse(resultat);
        }
//---------------------------------------------------------------------------

        plan_bateau tableau::liste_voisins(bateau* client,types_de_bateaux typ,liste_statuts statut_cherche)
        // renvoie une liste brassée de cases voisine d'un bateau de type défini (linéaire tordu etc..)
        // suivant la valeur de statut_cherche, renvoie les cases libres (pour construction d'un bateau)
        // ou les cases inconnue (pour recherche d'un coup à jouer).
        {
        plan_bateau resultat;
        std::vector<wxPoint> voisins_licites;
        // liste les cases qui peuvent être occupées au voisinage d'une case existante.
        // d'abord gauche droite et dessus dessous
        voisins_licites.push_back(wxPoint(-1,0));
        voisins_licites.push_back(wxPoint(0,-1));
        voisins_licites.push_back(wxPoint(1,0));
        voisins_licites.push_back(wxPoint(0,1));
        if ((typ==lineaires)&&(client->taille>1))
                {
                voisins_licites.clear();
                int vx=(client->plan[0]->ord()==client->plan[1]->ord()?1:0);
                int vy=(vx==1?0:1);
                voisins_licites.push_back(wxPoint(vx,vy));
                vx*=-1;
                vy*=-1;
                voisins_licites.push_back(wxPoint(vx,vy));
                }
        if (typ==par_les_sommets)
                {// dans ce cas on ajoute les cases d'angles
                voisins_licites.push_back(wxPoint(-1,-1));
                voisins_licites.push_back(wxPoint(1,-1));
                voisins_licites.push_back(wxPoint(1,1));
                voisins_licites.push_back(wxPoint(-1,1));
                };
        if (client->taille) //une longueur nulle retournera resultat vide
          {
                 for(int i=0;i<client->taille;i++) //pour toutes les cases du bateau
                        {
                        for (unsigned int j=0;j<voisins_licites.size();j++) // on examine toutes les cases voisines
                                {
                                int x=voisins_licites[j].x+client->plan[i]->abs();
                                int y=voisins_licites[j].y+client->plan[i]->ord();
                                bool hors_limite=(x<0)||(y<0)||(x>=largeur_tableau())||(y>=hauteur_tableau());
                                if (!hors_limite)
                                   {
                                    case_du_tableau* c=&contenu[x][y];
                                    if (std::find(resultat.begin(),resultat.end(),c )==resultat.end())
                                        if (!client->contient_case(*c))
                                           if (c->lit_statut()==statut_cherche) resultat.push_back(c);
                                    }
                                // seule une case absente de résultat est ajoutée
                                }
                        }
          }
        return brasse(resultat);
        }
//---------------------------------------------------------------------------
        void tableau::interdit_cases_autour_du_bateau(bateau* client)
        {
        plan_bateau voisins=liste_voisins(client,par_les_sommets,libre);
        int nb=voisins.size();
        if (nb)
                for (int i=0;i<nb;i++)
                        contenu[voisins[i]->abs()][voisins[i]->ord()].change_statut(interdite);
        }
//---------------------------------------------------------------------------
        int& tableau::largeur_tableau()
{       // cases numérotées de 0 à lartab-1
        static int lartab=taille_echiquier_courant();
        return lartab;
}
//---------------------------------------------------------------------------

        int& tableau::hauteur_tableau()
{       // cases numérotées de 0 à hauttab-1
        static int hauttab=taille_echiquier_courant();
        return hauttab;
}
        //---------------------------------------------------------------------------
        void tableau::garnit(liste_statuts st)
        {
        int L=largeur_tableau();
        int H=hauteur_tableau();
        for (int x=0;x<L;x++)
                for (int y=0;y<H;y++) contenu[x][y]=case_du_tableau(x,y,st,this);
        }
        //---------------------------------------------------------------------------
        void tableau::prepare_ecran(bool mach1,bool lui)
                {
                echiquier->parametres_internes.est_perso=false;
                echiquier->parametres_internes.est_machine1=mach1;
                echiquier->parametres_internes.est_lui=lui;
                echiquier->enable_on_off(false);
                echiquier->guirlande_on_off(!mach1);
                echiquier->visible_on_off(true);
                }
        //---------------------------------------------------------------------------
        void tableau::inscrit_bateau(const bateau& client)
        {
        for (int i=0;i<client.taille;i++)
                {case_du_tableau* c=client.plan[i];
                int x(c->abs());
                int y(c->ord());
                contenu[x][y].change_statut(c->lit_statut());
                }
        }
        //---------------------------------------------------------------------------
        // change la taille du tableau et de sa grille
        void tableau::resize()
        {
        hauteur_tableau()=taille_echiquier_courant();
        largeur_tableau()=taille_echiquier_courant();
        echiquier->resize();
        garnit(libre);
        }
        //---------------------------------------------------------------------------
        // Constructeur par défaut
        tableau::tableau()
        {
        init_tableau(wxT("inconnu"),inconnue);
        }
        //---------------------------------------------------------------------------
        // Constructeur explicite
        tableau::tableau(wxString nom_tab,liste_statuts st)
        {
        init_tableau(nom_tab,st);
        }
        //---------------------------------------------------------------------------
        // commun aux  constructeurs
        void tableau::init_tableau(wxString nom_tab,liste_statuts st)
        {
        int taille_max_vecteur=donneesStrat.taille_max_admissible_grille;
        contenu.clear();
        std::vector<case_du_tableau> colonne(taille_max_vecteur);
        for (int i=0;i<taille_max_vecteur;i++) contenu.push_back(colonne);
        nom=nom_tab;
        garnit(st);
        }

//---------------------------------------------------------------------------
//      Fin de l'objet tableau
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//      Implémentation de l'objet TTableau_personnalite
//---------------------------------------------------------------------------

        //---------------------------------------------------------------------------
        bool TTableau_personnalite::ecran_actif()
        {
        return echiquier->parametres_internes.echiquier_actif;
        }
        //---------------------------------------------------------------------------
        void TTableau_personnalite::prepare_ecran(bool mach1,bool lui)
                {
                echiquier->parametres_internes.est_perso=true;
                echiquier->parametres_internes.est_machine1=mach1;
                echiquier->parametres_internes.est_lui=lui;
                echiquier->enable_on_off(true);
                echiquier->guirlande_on_off(false);
                echiquier->visible_on_off(true);
                }

        //---------------------------------------------------------------------------
        TTableau_personnalite::TTableau_personnalite():echiquier(0)
        {
        }
//---------------------------------------------------------------------------
//      Fin de l'objet TTableau_personnalite
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//      Implémentation de l'objet bateau
//---------------------------------------------------------------------------
        //constructeurs
        bateau::bateau(tableau* t,int longueur)
        {
        proprietaire=t;
        taille=longueur;
        }
        //---------------------------------------------------------------------------
        bateau::bateau():proprietaire(0),taille(0)
        {
        }
        //---------------------------------------------------------------------------
        //Methodes
        wxString bateau::Nom()
        {nom_des_bateaux n;
        return n.nom_du(taille);
        }
        //---------------------------------------------------------------------------
        types_de_bateaux& bateau::forme()
        {static types_de_bateaux f=lineaires;
        return f;
        }
        //---------------------------------------------------------------------------
        bool bateau::coule()
        {bool glouglou=true;
        for(int i=0;i<taille;i++)
                  if (plan[i]->lit_statut()==occupee) glouglou=false;
        return glouglou;
        }
        //---------------------------------------------------------------------------
        // renvoie true si le bateau est formé de cases connexes conformément à sa forme
        bool bateau::cases_connexes()
        {bool connexe=true;
        bateau voisines;
        for (unsigned int i=0;i<plan.size();i++)
                {bateau b(proprietaire,0);
                bool co=false;
                b.ajoute_case(plan[i]);
                voisines.plan=proprietaire->liste_voisins(&b,forme(),occupee);
                for (unsigned int j=0;j<plan.size();j++)
                        if (j!=i)
                               co=co||voisines.contient_case(*plan[j]);
                connexe=connexe&&co;
                }
        return (connexe||taille==1);
        }
        //---------------------------------------------------------------------------
        // renvoie true si la case c est dans le bateau, quel que soit le statut de la case
        bool bateau::contient_case(case_du_tableau c)
        {bool reponse(false);
        for (unsigned int i=0;i<plan.size();i++)
                reponse=reponse||(  (c.ord()==plan[i]->ord())&&(c.abs()==plan[i]->abs()) );
        return reponse;
        }
        //---------------------------------------------------------------------------
        // vérifie que la case n'existe pas dans le bateau
        // retourne false si elle existe déjà
        // sinon ajoute la case au plan et incrémente la taille
        bool bateau::ajoute_case(case_du_tableau* c)
        {bool reponse=!contient_case(*c);
        if (reponse)
                {taille++;
                c->proprietaire=proprietaire;
                plan.push_back(c);
                }
        return reponse;
        }
//---------------------------------------------------------------------------
        // idem ajoute_case, mais fixe le statut à statut
        bool bateau::ajoute_case(case_du_tableau* c,liste_statuts statut)
        {
        bool reponse=ajoute_case(c);
        if (reponse) c->change_statut(statut);
        return reponse;
        }
//---------------------------------------------------------------------------
        // idem ajoute_case, mais fixe le statut à occupéé
        bool bateau::ajoute_case_occupee(case_du_tableau* c)
        {
        return ajoute_case(c,occupee);
        }
//---------------------------------------------------------------------------
        bool bateau::supprime_case(case_du_tableau* c)
        {
        bool possible=contient_case(*c);
        if (possible)
                {
                plan.erase(std::find(plan.begin(),plan.end(),c));
                taille=plan.size();
                c->change_statut(libre);
                // annule les modifications si la suppression rend le bateau invalide
                if (!cases_connexes()) ajoute_case_occupee(c);
                }
        return possible;
        }
//---------------------------------------------------------------------------
        int bateau::nb_cotes_au_bord()
        // Retourne le nombre de faces touchant le bord de l'échiquier
        {int resultat=0;
        for (unsigned int i=0;i<plan.size();i++)
                if (plan[i]->case_au_bord())
                        resultat++;
        return resultat;
        }
//---------------------------------------------------------------------------
        int bateau::mode()
        // retourne le mode utilisé pour la formule de compacité
        // et de mode m, m étant 1 (coin), 2 (marginal) 3(droit) 4 (tordu ou par les côtés)
        {
        int resultat=3;
        if (forme()==tordus||forme()==par_les_sommets) resultat=4;
        for (unsigned int i=0;i<plan.size();i++)
                {
                if (plan[i]->case_au_bord()) resultat=2;
                if (plan[i]->case_en_coin())
                        {resultat=1;
                        i=plan.size();
                        }
                }
        return resultat;
        }
//---------------------------------------------------------------------------
        void bateau::clone(bateau* nouveau_bateau)
        // recopie les données de façon valide dans un nouveau bateau équivalent
        // le nouveau bateau contient les mêmes cases, disposées de façon identique
        // mais le statut n'est pas modifié, c'est celui de la case correspondante du propriétaire de nouveau_bateau

        {
        nouveau_bateau->plan.clear();
        for (unsigned int i=0;i<plan.size();i++)
                {
                nouveau_bateau->plan.push_back(&nouveau_bateau->proprietaire->contenu[plan[i]->abs()][plan[i]->ord()]);
                }
        nouveau_bateau->taille=taille;
        }
//---------------------------------------------------------------------------
        // opérateur d'addition + de bateau.
        bateau bateau::operator+(const bateau& b)
        {
        bateau resultat=b;
        for (unsigned int i=0;i<plan.size();i++)
                if (!resultat.contient_case(*plan[i])) resultat.ajoute_case(plan[i]);
        return resultat;
        }
//---------------------------------------------------------------------------
        // opérateur d'addition += de bateau.
        void bateau::operator+=(const bateau& b)
        {
        (*this)=(*this)+b;
        }
//---------------------------------------------------------------------------
//      Fin de l'objet bateau
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Implémentation de l'objet Tpersonnalite
//---------------------------------------------------------------------------
        void Tpersonnalite::formate_nom(wxString nom)
        //---------------------------------------------------------------------------
        // met à jour le nom formaté de la personnalité
        {wxString NomLong=nom+wxT("               ");
        for (int i=0;i<14;i++) nomformate[i]=NomLong[i];
        nomformate[14]='\0';
        }
        //---------------------------------------------------------------------------
        // efface les données de la personnalité (sauf le nom)
        void Tpersonnalite::purge()
        {
        int largeur=taille_grille_profiles();
        age=0;
        victoires=0;
        for (int i=0;i<largeur;i++)
                for (int j=0;j<largeur;j++) profile[i][j]=0;

        }
        //---------------------------------------------------------------------------
        // sort une valeur formatée entre 0 et 5
        float Tpersonnalite::valeur_profile(int comp,int marg)
        {float resultat,max,min;
        int largeur=taille_grille_profiles();
        max=profile[0][0];min=max;
        for (int i=0;i<largeur;i++)
             for (int j=0;j<largeur;j++)
                {
                max=(max<profile[i][j]?profile[i][j]:max);
                min=(min>profile[i][j]?profile[i][j]:min);
                }
        resultat=(profile[comp][marg]-min)/(max-min+0.1)*5;
        return resultat;
        }
        //---------------------------------------------------------------------------
        wxString Tpersonnalite::extrait_nom()
        // enlève les espaces à la fin du nom formaté
        {int der=14;
        for (int i=13;i>=0;i--)
                if (nomformate[i]!=' '){der=i+1;i=0;}
        wxString nf;
        nf=nomformate;;
        wxString rep(nf,der);
        return rep;
        }
        //---------------------------------------------------------------------------
        // constructeur
        Tpersonnalite::Tpersonnalite(wxString nom)
        {
        formate_nom(nom);
        purge();
        }
//---------------------------------------------------------------------------
//      Fin implémentation de l'objet Tpersonnalite
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Implémentation de l'objet Tliste_joueurs
//---------------------------------------------------------------------------
        void Tliste_joueurs::liste_par_defaut()
        {
        Tpersonnalite p1(baMACHINE1),p2(baMACHINE2);
        contenu.clear();
        push_back(p1);
        push_back(p2);
        }
        //---------------------------------------------------------------------------
        bool Tliste_joueurs::contient(wxString nom)
        { bool resultat=false;
          for (std::vector<Tpersonnalite>::iterator i=contenu.begin();i<contenu.end();++i)
                if(i->extrait_nom()==nom) resultat=true; ;
          return resultat;
        }
        //---------------------------------------------------------------------------
        int Tliste_joueurs::index_de(wxString nom)
        {int resultat=-1;
        for (unsigned int i=0;i<contenu.size();i++)
                if (contenu[i].extrait_nom()==nom) {resultat=i;i=contenu.size();}
        return resultat;
        }
        //---------------------------------------------------------------------------
        void Tliste_joueurs::push_back(Tpersonnalite p)
        {contenu.push_back(p);}
        //---------------------------------------------------------------------------
        void Tliste_joueurs::clear()
        {contenu.clear();}
        //---------------------------------------------------------------------------
        void Tliste_joueurs::erase(int p) // efface le pième élément (numéroté à partir de 0)
        {contenu.erase(contenu.begin()+p);}
        //---------------------------------------------------------------------------
        unsigned int Tliste_joueurs::size()
        {return contenu.size();}
        //---------------------------------------------------------------------------
        Tpersonnalite& Tliste_joueurs::operator[](int i)
        {
        return contenu[i];
        }
        //---------------------------------------------------------------------------
        Tliste_joueurs::Tliste_joueurs()
        {liste_par_defaut();}
//---------------------------------------------------------------------------
//      Fin mplémentation de l'objet Tliste_joueurs
//---------------------------------------------------------------------------
        Tliste_joueurs& liste_joueurs()
        {
            static Tliste_joueurs lj;
            return lj;
        }
        // Les joueurs
        TJoueur& Machine1()
        {
            static TJoueur J1(baMACHINE1);
            return J1;
        }
        TJoueur& Machine2()
        {
            static TJoueur J2(baMACHINE2);
            return J2;
        }
//---------------------------------------------------------------------------
//      Implémentation de l'objet TJeu
//---------------------------------------------------------------------------
        //TJeu représente un échiquier et sa flottille
        //ainsi que sa personnalité connue ou supposée
        // constructeur
        TJeu::TJeu(wxString nom_jeu,liste_statuts st):son_tableau(nom_jeu,st),personnalite(nom_jeu)
        {
        nom=nom_jeu;
        son_tableau.echiquier=NULL; // pas de canvas valide par défaut
        }
        //---------------------------------------------------------------------------
        // Un jeu possède un tableau qui pointe vers un Canvas d'affichage
        // le canvas doit lui-même pointer vers le contenu physique du tableau
        void TJeu::associe_canvas(Tgraphique* Canvas_associe)
        {
        son_tableau.echiquier=Canvas_associe;
        son_tableau.echiquier->parametres_internes.ech_contenu=(&son_tableau.contenu);
        }
        //---------------------------------------------------------------------------
        bool TJeu::ajoute_valeur_personnalite(int comp,int marg,bool vainqueur)
        {
        bool reponse=(comp>=0)&&(comp<5)&&(marg>=0)&&(marg<5);
        personnalite.age++;
        if (vainqueur) personnalite.victoires++;
        if (reponse) personnalite.profile[comp][marg]+=(vainqueur?1:-1);
        return reponse;
        }
        //---------------------------------------------------------------------------
        // Cherche si c appartient à un des bateaux de la flottille.
        // renvoie un bateau de taille nulle en cas d'insuccès
        bateau TJeu::quel_bateau(case_du_tableau c)
        {bateau reponse,bonne_reponse;
        for (unsigned int i=0;i<flottille.size();i++)
                {reponse=flottille[i];
                for (int j=0;j<reponse.taille;j++)
                        {case_du_tableau cible= (*reponse.plan[j]);
                        if ((cible.abs()==c.abs())&&(cible.ord()==c.ord()))
                                   bonne_reponse=reponse;
                        }
                }
        return bonne_reponse;
        }
        //---------------------------------------------------------------------------
        //Cherche si c fait partie du prolongement licite d'un bateau existant
        //renvoie l'indice de ce bateau dans la flottille
        //renvoie -1 si c est un nouveau bateau
        int TJeu::indice_du_bateau_incomplet(case_du_tableau c)
        {int reponse=-1;
        bateau b;
        plan_bateau cases_possibles;

        for (unsigned int i=0;i<flottille.size();i++)
                {cases_possibles=son_tableau.liste_voisins(&flottille[i],b.forme(),libre);
                for (unsigned int j=0;j<cases_possibles.size();j++)
                        if (c.memes_coordonnees(*cases_possibles[j]))
                                reponse=i;
                }
        return reponse;
        }
        //---------------------------------------------------------------------------
        void TJeu::coup_deponge(liste_statuts st)
        // efface la tableau du jeu mais pas sa personnalité
        {
        flottille.clear();
        son_tableau.garnit(st);
        }
        //---------------------------------------------------------------------------
        void TJeu::clone(TJeu* Jeu_nouveau)
        // recopie les données de façon valide dans un nouveau jeu équivalent
        {
        Jeu_nouveau->coup_deponge(libre);
        Jeu_nouveau->personnalite=personnalite;
        for (unsigned int i=0;i<flottille.size();i++)
                {bateau b(&Jeu_nouveau->son_tableau,0);
                for (int j=0;j<flottille[i].taille;j++)
                        {
                        case_du_tableau c1= (*flottille[i].plan[j]);
                        case_du_tableau c2(c1.abs(),c1.ord(),c1.lit_statut(),&Jeu_nouveau->son_tableau);
                        Jeu_nouveau->son_tableau.contenu[c2.abs()][c2.ord()]=c2;
                        b.ajoute_case(&Jeu_nouveau->son_tableau.contenu[c2.abs()][c2.ord()]);
                        }
                Jeu_nouveau->flottille.push_back(b);
                }
        for (int i=0;i<son_tableau.largeur_tableau();i++)
                for (int j=0;j<son_tableau.hauteur_tableau();j++)
                        Jeu_nouveau->son_tableau.contenu[i][j].change_statut(son_tableau.contenu[i][j].lit_statut());
        }
//---------------------------------------------------------------------------
//      Fin de l'objet TJeu
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Debut de l'objet TJoueur
//---------------------------------------------------------------------------
        // Constructeur
        TJoueur::TJoueur(wxString nom_joueur):nom(nom_joueur),lui(wxT("Lui même"),libre),adversaire(wxT("adversaire"),libre)
        {
        }
        //---------------------------------------------------------------------------
        void TJoueur::vide_memoire()
        {
        memoire.reserve_de_cases_a_jouer.clear();
        memoire.flottille_adversaire.clear();
        memoire.bateau_repere=false;
        }
        //---------------------------------------------------------------------------
        void TJoueur::coup_deponge()
        {// efface la memoire et les grilles mais pas la personnalité
        lui.coup_deponge(libre);
        adversaire.coup_deponge(libre);
        vide_memoire();
        }
//---------------------------------------------------------------------------
        bool TJoueur::affecte_personnalite()
        //affecte au jeu "lui" du joueur la personnalité existant dans le liste_joueurs à l'entrée "nom"
        // retourne faux si aucun joueur de ce nom n'est trouvé
        // dans ce cas la personnalité reste la personnalité par défaut
        {
        bool reponse=false;
        for (unsigned int i=0;i<liste_joueurs().size();i++)
                {wxString n=liste_joueurs()[i].extrait_nom();
                if (n==nom)
                        {reponse=true;
                        lui.personnalite=liste_joueurs()[i];
                        }
                if (n==adversaire.nom)
                        adversaire.personnalite=liste_joueurs()[i];
                }
        return reponse;
        }
 //---------------------------------------------------------------------------
        void TJoueur::clone_memoire(TJoueur* joueur_nouveau)
        {
        joueur_nouveau->memoire.bateau_repere=memoire.bateau_repere;
        joueur_nouveau->memoire.case_jouee=memoire.case_jouee;
        for (unsigned int i=0;i<memoire.reserve_de_cases_a_jouer.size();i++)
                {
                case_du_tableau c=*memoire.reserve_de_cases_a_jouer[i];
                case_du_tableau* c1=&joueur_nouveau->adversaire.son_tableau.contenu[c.abs()][c.ord()];
                joueur_nouveau->memoire.reserve_de_cases_a_jouer.push_back(c1);
                }
        for (unsigned int i=0;i<memoire.flottille_adversaire.size();i++)
                {bateau b(&joueur_nouveau->adversaire.son_tableau,0);
                for (int j=0;j<memoire.flottille_adversaire[i].taille;j++)
                        {
                        case_du_tableau c1= (*memoire.flottille_adversaire[i].plan[j]);
                        b.ajoute_case(&joueur_nouveau->adversaire.son_tableau.contenu[c1.abs()][c1.ord()]);
                        }
                joueur_nouveau->memoire.flottille_adversaire.push_back(b);
                }
        }
 //---------------------------------------------------------------------------
        void TJoueur::clone(TJoueur* joueur_nouveau)
        // recopie les données de façon valide dans un nouveau joueur équivalent
        {joueur_nouveau->coup_deponge();
        lui.clone(&joueur_nouveau->lui);
        adversaire.clone(&joueur_nouveau->adversaire);
        clone_memoire(joueur_nouveau);
        }
//---------------------------------------------------------------------------
//      Fin de l'objet Tjoueur
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Fenêtre principale
//---------------------------------------------------------------------------

//Identificateurs
const long MainFrame::id_frame = wxNewId();
const long MainFrame::idMenuQuit = wxNewId();
const long MainFrame::idMenuProprietes = wxNewId();
const long MainFrame::idMenuCalcule = wxNewId();
const long MainFrame::idMenuStop = wxNewId();
const long MainFrame::idMenuPerso = wxNewId();
const long MainFrame::idMenuDisclaimer = wxNewId();
const long MainFrame::idMenuAbout = wxNewId();
const long MainFrame::idMenuHelp = wxNewId();
const long MainFrame::idMenuMachHom = wxNewId();
const long MainFrame::idMenuMachMach100 = wxNewId();
const long MainFrame::idMenuMachMach = wxNewId();
const long MainFrame::idMenufr = wxNewId();
const long MainFrame::idMenuen = wxNewId();
const long MainFrame::idMenues = wxNewId();
const long MainFrame::idMenuToolbar1 = wxNewId();
const long MainFrame::ID_DIALOGS_FILES_OPEN = wxNewId();
const long MainFrame::ID_DIALOGS_FILE_SAVE = wxNewId();
const long MainFrame::ID_DIALOGS_FILE_SAVE_AS = wxNewId();
const long MainFrame::idOnPaint = wxNewId();
const long MainFrame::idaproposinst = wxNewId();
const long MainFrame::idficheperso = wxNewId();

// identifiants des contrôles
const long MainFrame::idPanelGauche = wxNewId();
const long MainFrame::idStaticBoxDroit = wxNewId();
const long MainFrame::idChoixForme= wxNewId();
const long MainFrame::idChoixTaille= wxNewId();
const long MainFrame::idDialogues= wxNewId();
const long MainFrame::idBoutaleau= wxNewId();
const long MainFrame::idBoutouche= wxNewId();
const long MainFrame::idBoutcoule= wxNewId();
const long MainFrame::idLabEchap= wxNewId();

// identifiants des canvas
const long MainFrame::idCanvas1= wxNewId();
const long MainFrame::idCanvas2= wxNewId();
const long MainFrame::idCanvas3= wxNewId();
const long MainFrame::idCanvas4= wxNewId();

//---------------------------------------------------------------------------
BEGIN_EVENT_TABLE(MainFrame, wxFrame)
    EVT_PAINT(MainFrame::OnPaint)
    EVT_CLOSE(MainFrame::OnClose)
    EVT_RADIOBOX(idChoixForme,MainFrame::OnChoixForme)
    EVT_RADIOBOX(idChoixTaille,MainFrame::OnChoixTaille)
    EVT_MENU(idMenuQuit, MainFrame::OnQuit)
    EVT_MENU(ID_DIALOGS_FILES_OPEN, MainFrame::FileOpen)
    EVT_MENU(ID_DIALOGS_FILE_SAVE, MainFrame::FileSave)
    EVT_MENU(ID_DIALOGS_FILE_SAVE_AS, MainFrame::FileSaveAs)
    EVT_MENU(idMenuDisclaimer, MainFrame::OnDisclaimer)
    EVT_MENU(idMenuAbout, MainFrame::OnAbout)
    EVT_MENU(idMenuHelp, MainFrame::OnHelp)
    EVT_MENU(idMenuProprietes, MainFrame::OnProprietes)
    EVT_MENU(idMenuCalcule,MainFrame::OnCalcule)
    EVT_MENU(idMenuStop,MainFrame::OnStop)
    EVT_MENU(idMenuPerso,MainFrame::OnFichePerso)
    EVT_MENU(idMenufr,MainFrame::Onfr)
    EVT_MENU(idMenuen,MainFrame::Onen)
    EVT_MENU(idMenues,MainFrame::Ones)
    EVT_MENU(idMenuMachHom,MainFrame::OnMachHom)
    EVT_MENU(idMenuMachMach,MainFrame::OnMachMach)
    EVT_MENU(idMenuMachMach100,MainFrame::OnMachMach100)
    EVT_BUTTON(idBoutaleau,MainFrame::OnBoutaleau)
    EVT_BUTTON(idBoutouche,MainFrame::OnBoutouche)
    EVT_BUTTON(idBoutcoule,MainFrame::OnBoutcoule)
    EVT_BUTTON(APropos::idAProposQuit,MainFrame::OnCloseAbout)
    EVT_COMMAND(wxID_ANY, wxEVT_COMMAND_BUTTON_CLICKED, MainFrame::OnCloseAbout)
END_EVENT_TABLE()
//---------------------------------------------------------------------------
// Le constructeur
MainFrame::MainFrame() : wxFrame(NULL,id_frame,wxT("Bataille navale"),wxPoint(800,100),wxSize(100,100),wxDEFAULT_FRAME_STYLE|wxFULL_REPAINT_ON_RESIZE)
                            ,init_done(false),item_menu_change(true)

{
    firstwin()=this;
    Traducteur tr;
    tr.langue_demarrage();
    SetBackgroundColour(Couleur_Fenetres_defaut());
    // Calcule la taille de départ de la fenêtre
    SetSize(Taille_Fenetres_defaut());
    // Calcule la taille minimale de la fenêtre (ne marche pas avec Wine)
    SetSizeHints(300,200,-1,-1,-1,-1);
    FixeFontEtTaille(this);
    SetIcon(batanav16_xpm);
    Canvas1= new Tgraphique(this,idCanvas1,wxPoint(100,100),wxSize(100,100),taille_echiquier_courant(),wxT("Grille de l'adversaire"));
    Canvas2= new Tgraphique(this,idCanvas2,wxPoint(100,100),wxSize(100,100),taille_echiquier_courant(),wxT("Votre grille vue par l'adversaire"));

    Machine1().lui.associe_canvas(Canvas1);
    Machine1().adversaire.associe_canvas(Canvas2);
    Machine1().lui.son_tableau.prepare_ecran(true,true);
    Machine1().adversaire.son_tableau.prepare_ecran(true,false);
    Canvas3= new Tgraphique(this,idCanvas3,wxPoint(100,100),wxSize(100,100),taille_echiquier_courant(),wxT("Votre grille"));
    Canvas4= new Tgraphique(this,idCanvas4,wxPoint(100,100),wxSize(100,100),taille_echiquier_courant(),wxT("Grille de l'adversaire connue à ce stade"));
    Machine2().lui.associe_canvas(Canvas3);
    Machine2().adversaire.associe_canvas(Canvas4);
    Machine2().lui.son_tableau.prepare_ecran(false,true);
    Machine2().adversaire.son_tableau.prepare_ecran(false,false);
    AProposinst=new APropos(this,idaproposinst);
    PersoJoueur=new FichePerso(this,idficheperso,&Machine1().lui.personnalite,&Machine2().lui.personnalite);

    //---------------------------------------------------------------------------
    // Mise en place des menus
    wxMenuItem* MenuItem1;
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem3;
    wxMenuItem* MenuItem4;
    wxMenuItem* MenuItem5;
    wxMenuItem* MenuItem6;
    wxMenuItem* MenuItem7;
    wxMenuItem* MenuItem8;
    wxMenuItem* MenuItem9;
    wxMenuItem* MenuItem10;
    wxMenuItem* MenuItem11;
    wxMenuItem* MenuItem12;
    wxMenuItem* MenuItem13;
    wxMenuItem* MenuItem14;
    wxMenuItem* MenuItem15;
    wxMenuItem* MenuItem16;
    wxMenuItem* MenuItem17;
    wxMenu* Menu1;
    wxMenu* Menu2;
    wxMenu* Menu3;
    wxMenu* Menu4;
    wxMenu* Menu5;
    wxMenuBar* MenuBar1;
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
        MenuItem1 = new wxMenuItem(Menu1, ID_DIALOGS_FILES_OPEN, wxT("&Ouvrir"), wxT("Charge un fichier"), wxITEM_NORMAL);
        Menu1->Append(MenuItem1);
        MenuItem2 = new wxMenuItem(Menu1, ID_DIALOGS_FILE_SAVE, wxT("&Enregistrer"), wxT("Sauve le fichier en cours"), wxITEM_NORMAL);
        Menu1->Append(MenuItem2);
        MenuItem3 = new wxMenuItem(Menu1,ID_DIALOGS_FILE_SAVE_AS, wxT("Enregistrer &sous..."), wxT("Sauv sous un nouveau nom"), wxITEM_NORMAL);
        Menu1->Append(MenuItem3);
        Menu1->AppendSeparator();
        MenuItem4 = new wxMenuItem(Menu1, idMenuQuit, wxT("Quit\tAlt-F4"), wxT("Quit the application"), wxITEM_NORMAL);
        Menu1->Append(MenuItem4);
        MenuBar1->Append(Menu1, wxT("Fichiers"));

    Menu2 = new wxMenu();
        MenuItem5 = new wxMenuItem(Menu2, idMenuProprietes, wxT("&Qualités de la grille"), wxT("&Qualités de la grille"), wxITEM_NORMAL);
        Menu2->Append(MenuItem5);
        Menu2->AppendSeparator();
        MenuItem6 = new wxMenuItem(Menu2, idMenuCalcule, wxT("Lance une partie"), wxT("Lance une partie"), wxITEM_CHECK);
        Menu2->Append(MenuItem6);
        Menu2->Check(idMenuCalcule,false);
        MenuItem7 = new wxMenuItem(Menu2, idMenuStop, wxT("Arrête"), wxT("Arrête"), wxITEM_CHECK);
        Menu2->Append(MenuItem7);
        Menu2->Check(idMenuStop,true);
        Menu2->AppendSeparator();
        MenuItem8 = new wxMenuItem(Menu2, idMenuPerso, wxT("&Personnalité"), wxT("personnalité"), wxITEM_NORMAL);
        Menu2->Append(MenuItem8);
        MenuBar1->Append(Menu2, wxT("Outils"));

    Menu3 = new wxMenu();
        MenuItem9 = new wxMenuItem(Menu3, idMenuMachHom, wxT("Machine <-> &homme"), wxT("Machine / homme"), wxITEM_RADIO );
        Menu3->Append(MenuItem9);
        MenuItem10 = new wxMenuItem(Menu3, idMenuMachMach100, wxT("Machine / Machine (100)"), wxT("Machine / Machine (200 parties)"), wxITEM_RADIO );
        Menu3->Append(MenuItem10);
        MenuItem11 = new wxMenuItem(Menu3, idMenuMachMach, wxT("Machine / Machine"), wxT("Machine / Machine"), wxITEM_RADIO );
        Menu3->Append(MenuItem11);
        MenuBar1->Append(Menu3, wxT("Mode"));

    Menu4 = new wxMenu();
        MenuItem12 = new wxMenuItem(Menu4, idMenufr, wxT("Français"), wxT("Version Française"), wxITEM_CHECK );
        Menu4->Append(MenuItem12);
        MenuItem13 = new wxMenuItem(Menu4, idMenuen, wxT("English"), wxT("English version"), wxITEM_CHECK );
        Menu4->Append(MenuItem13);
        MenuItem14 = new wxMenuItem(Menu4, idMenues, wxT("Castellano"), wxT("Versión Castellana"), wxITEM_CHECK );
        Menu4->Append(MenuItem14);

        MenuBar1->Append(Menu4, wxT("Langue"));

    Menu5 = new wxMenu();
        MenuItem15 = new wxMenuItem(Menu5, idMenuDisclaimer, wxT("Avertissement"), wxT("Avertissement"), wxITEM_NORMAL);
        Menu5->Append(MenuItem15);
        MenuItem16 = new wxMenuItem(Menu5, idMenuAbout, wxT("About\tF1"), wxT("Show info about this application"), wxITEM_NORMAL);
        Menu5->Append(MenuItem16);
        MenuItem17 = new wxMenuItem(Menu5, idMenuHelp, wxT("Aide"), wxT("Aide sur batanav"), wxITEM_NORMAL);
        Menu5->Append(MenuItem17);
        MenuBar1->Append(Menu5, wxT("Aide"));
    SetMenuBar(MenuBar1);
    //---------------------------------------------------------------------------
    // Barre d'outils
    wxToolBar* Toolbar1;
    Toolbar1= CreateToolBar(wxNO_BORDER | wxTB_HORIZONTAL,idMenuToolbar1);
    wxImage::AddHandler(new wxXPMHandler());
    wxBitmap* toolBarBitmaps[9];
    toolBarBitmaps[0]=new wxBitmap(files16_xpm);
    toolBarBitmaps[1]=new wxBitmap(save16_xpm);
    toolBarBitmaps[2]=new wxBitmap(go16_xpm);
    toolBarBitmaps[3]=new wxBitmap(delete16_xpm);
    toolBarBitmaps[4]=new wxBitmap(fr16_xpm);
    toolBarBitmaps[5]=new wxBitmap(eng16_xpm);
    toolBarBitmaps[6]=new wxBitmap(es16_xpm);
    toolBarBitmaps[7]=new wxBitmap(chapeau16_xpm);
    toolBarBitmaps[8]=new wxBitmap(help16_xpm);
    toolBarBitmaps[9]=new wxBitmap(sortie16_xpm);

    Toolbar1->SetToolBitmapSize(wxSize(toolBarBitmaps[0]->GetWidth(),toolBarBitmaps[0]->GetHeight()));

    Toolbar1->AddTool(ID_DIALOGS_FILES_OPEN ,wxT("&Ouvrir")        ,*(toolBarBitmaps[0]),wxT("&Ouvrir")                   ,wxITEM_NORMAL);
    Toolbar1->AddTool(ID_DIALOGS_FILE_SAVE  ,wxT("Sauve le fichier en cours")    ,*(toolBarBitmaps[1]),wxT("Sauve le fichier en cours")  ,wxITEM_NORMAL);
    Toolbar1->AddSeparator();
    Toolbar1->AddRadioTool(idMenuStop            ,wxT("Arrête")           ,*(toolBarBitmaps[3]),*(toolBarBitmaps[3]),wxT("Arrête"));
    Toolbar1->AddRadioTool(idMenuCalcule         ,wxT("Lance une partie") ,*(toolBarBitmaps[2]),*(toolBarBitmaps[2]),wxT("Lance une partie"));
    Toolbar1->AddSeparator();
    Toolbar1->AddRadioTool(idMenufr              ,wxT("Français")         ,*(toolBarBitmaps[4]),*(toolBarBitmaps[4]),wxT("Français"));
    Toolbar1->AddRadioTool(idMenuen              ,wxT("English")          ,*(toolBarBitmaps[5]),*(toolBarBitmaps[5]),wxT("English" ));
    Toolbar1->AddRadioTool(idMenues              ,wxT("español")          ,*(toolBarBitmaps[6]),*(toolBarBitmaps[6]),wxT("español" ));
    Toolbar1->AddSeparator();
    Toolbar1->AddTool(idMenuPerso           ,wxT("Personnalité")   ,*(toolBarBitmaps[7]),wxT("Personnalité")               ,wxITEM_NORMAL);
    Toolbar1->AddSeparator();
    Toolbar1->AddTool(idMenuHelp            ,wxT("Aide")            ,*(toolBarBitmaps[8]),wxT("Aide")                       ,wxITEM_NORMAL);
    Toolbar1->AddSeparator();
    Toolbar1->AddTool(idMenuQuit            ,wxT("Quitter")         ,*(toolBarBitmaps[9]),wxT("Sortie")                     ,wxITEM_NORMAL);
    Toolbar1->Realize();
    SetToolBar(Toolbar1);
    //---------------------------------------------------------------------------
    // Mise en page et insertion des contrôles
    wxPoint pos; wxSize taille;
    // Etiquettes
    pos=FaitReelle_Pos(wxPoint(400,40),this);
    LabEchap=new wxStaticText(this,idLabEchap,wxT("Echap pour interrompre"),pos);

    // Panneau de contrôle indispensable sinon les évènements mouse ne sont pas émis par la wxRadiobox (bogue
    // corrigée dans les versions suivantes de wxWidgets
    pos=FaitReelle_Pos(wxPoint(300,600),this);  taille=FaitReelle_Taille(wxSize(10,10),this);
    BoutonsRadio= new wxPanel(this,wxID_ANY,pos,taille);
    // Boutons de réponse
    pos=FaitReelle_Pos(wxPoint(10,10),BoutonsRadio);  taille=FaitReelle_Taille(wxSize(140,300),BoutonsRadio);
    Boutaleau=new wxButton(BoutonsRadio,idBoutaleau,wxT("A l'eau!"),pos,taille);
    pos=FaitReelle_Pos(wxPoint(10,310),BoutonsRadio);
    Boutouche=new wxButton(BoutonsRadio,idBoutouche,wxT("Touché!"),pos,taille);
    pos=FaitReelle_Pos(wxPoint(10,620),BoutonsRadio);
    Boutcoule=new wxButton(BoutonsRadio,idBoutcoule,wxT("coulé"),pos,taille);
    Boutaleau->Enable(false);
    Boutouche->Enable(false);
    Boutcoule->Enable(false);
    // Boutson radio choix de la forme des bateaux
    pos=FaitReelle_Pos(wxPoint(160,10),BoutonsRadio);
    taille=FaitReelle_Taille(wxSize(190,900),BoutonsRadio);
    ChoixForme =new wxRadioBox(BoutonsRadio,idChoixForme ,wxT("Forme bateaux"),pos,taille,3,nomforme,1,wxRA_SPECIFY_COLS);
    // Boutson radio choix de la taille de la grille
    pos=FaitReelle_Pos(wxPoint(360,100),BoutonsRadio);
    ChoixTaille=new wxRadioBox(BoutonsRadio,idChoixTaille,wxT("grille")       ,pos,taille,3,nomtaille,1,wxRA_SPECIFY_COLS);
    ChoixTaille->SetSelection(1);
    // Fenêtre de dialogues
    pos=FaitReelle_Pos(wxPoint(560,10),BoutonsRadio);
    taille=FaitReelle_Taille(wxSize(400,900),BoutonsRadio);
    Dialogues=new wxTextCtrl(BoutonsRadio,idDialogues,wxString(wxT("")),pos,taille,wxTE_LEFT|wxTE_MULTILINE|wxTE_READONLY);
    Machine2().lui.son_tableau.echiquier->visible_on_off(true);
    Machine2().adversaire.son_tableau.echiquier->visible_on_off(true);
    // Initialisation des chemins

    //wxStandardPaths Chemins; // wxStandardPaths est protected dans wxWidgets 3 donc pas instanciable
#if defined(__WXMSW__)
    InitDir=wxStandardPaths::Get().GetDataDir();
    DonneesDir=InitDir;
    DonneesVarDir=DonneesDir;
#elif defined(__UNIX__)
    //Chemins.SetInstallPrefix(wxT("/usr/games"));
    //InitDir=Chemins.GetInstallPrefix();
    InitDir=wxT("/usr/games");
    DonneesDir=wxT("/usr/share/batanav"); // Le répertoire usr peut-être en lecture seule
    DonneesVarDir=wxT("/var/lib/batanav");// d'où la nécessité d'un répertoire dans var pour les données modifiables
#endif
    // Aide
    wxImage::AddHandler(new wxPNGHandler());
    wxFileSystem::AddHandler(new wxZipFSHandler);
    helpController = new wxHtmlHelpController(wxHF_DEFAULT_STYLE,this);
    helpController->Initialize(DonneesDir+wxT("/")+wxT("batanavfrahlp.zip"));
     helpController->AddBook(wxFileName(DonneesDir+wxT("/")+wxT("batanavenghlp.zip")));
    helpController->AddBook(wxFileName(DonneesDir+wxT("/")+wxT("batanavesphlp.zip")));
    NomFichier=wxT("default.batnav");
    // Charge l'arbre par défaut le crée s'il n'existe pas
    if(!charge_fichier(NomComplet()))
        {wxCommandEvent ev;
        FileSave(ev);
        charge_fichier(NomComplet());
        }
    init_done=true;
}
//---------------------------------------------------------------------------
// Le Destructeur
MainFrame::~MainFrame()
{
}
//---------------------------------------------------------------------------
/*
wxString MainFrame::Indicateur()// Utilisé pour deboguage
{
    wxString ind1,ind2,ind3,ind4, ind5;
    wxToolBar* Toolbarprov=GetToolBar();
    ind1=(superviseur::partie_en_cours()?wxT("jY "):wxT("jN "));
    ind2=(Toolbarprov->GetToolState(idMenuCalcule)?wxT("cTY "):wxT("cTN "));
    ind3=(Toolbarprov->GetToolEnabled(idMenuCalcule)?wxT("cEY "):wxT("cEN "));
    ind4=(Toolbarprov->GetToolState(idMenuStop)?wxT("sTY "):wxT("sTN "));
    ind5=(Toolbarprov->GetToolEnabled(idMenuStop)?wxT("sEY "):wxT("sEN "));
    return ind1+ind2+ind3+ind4+ind5;
}
*/
//---------------------------------------------------------------------------
wxPoint MainFrame::ALaPlace(int x,int y)
{
    return wxPoint(GetSize().GetWidth()/100*x,GetSize().GetHeight()/100*y);
}
//---------------------------------------------------------------------------
wxString MainFrame::NomComplet()
{
    return DonneesVarDir+wxT("/")+NomFichier;
}
//---------------------------------------------------------------------------
void MainFrame::OnQuit(wxCommandEvent& event)
{
                wxCloseEvent eventclose;
                OnClose(eventclose);
}
void MainFrame::OnClose(wxCloseEvent& event)
{
                // En cas de partie automatique lancée, empêche la fermeture du programme
                // tant que la partie n'est pas terminée
                // Il faudra représser un bouton d'arrêt pour sortir du programme
                if (!donneesStrat.machine_contre_humain()&&superviseur::partie_en_cours())
                        superviseur::interruption_demandee()=true;
                else
                this->Destroy();
}
//---------------------------------------------------------------------------
void MainFrame::OnDisclaimer(wxCommandEvent& event)
{
    Traducteur tr;
    wxBitmap bitmap;
    wxImage::AddHandler(new wxPNGHandler());

    if (bitmap.LoadFile(DonneesDir+wxT("/")+tr.trad(wxT("DisclaimimageFra.png")), wxBITMAP_TYPE_PNG))
    {
        wxSplashScreen* splash __attribute__ ((unused));
        splash = new wxSplashScreen(bitmap,
          wxSPLASH_CENTRE_ON_SCREEN|wxSPLASH_TIMEOUT,
          6000, NULL, -1, wxDefaultPosition, wxDefaultSize,
          wxSIMPLE_BORDER|wxSTAY_ON_TOP);
    }
    wxYield();
}
void MainFrame::OnAbout(wxCommandEvent& event)
{
    AProposinst->Show();
}
 void MainFrame::OnHelp(wxCommandEvent& event)
{
    Traducteur tr;
    helpController->DisplayContents();
    helpController->Display(tr.trad(wxT("batnavfra")));
}
void MainFrame::OnCloseAbout(wxCommandEvent& event)
{
        wxString message= event.GetString();
        if (message==wxT("Fermeture"))
            AProposinst->Hide();
}
void MainFrame::Onfr(wxCommandEvent& event)
{
    Traducteur tr;
    tr.fixe_langue()=fr;
    item_menu_change=true;
    Refresh();
}
void MainFrame::Onen(wxCommandEvent& event)
{
    Traducteur tr;
    tr.fixe_langue()=ang;
    item_menu_change=true;
    Refresh();
}
void MainFrame::Ones(wxCommandEvent& event)
{
    Traducteur tr;
    tr.fixe_langue()=esp;
    item_menu_change=true;
    Refresh();
}
//---------------------------------------------------------------------------
// Chargemement du fichier batnav sélectionné.
// charge le fichier des personnalités
bool MainFrame::charge_fichier(wxString nomfich)
{
    Traducteur tr;
    wxFile fichier_en_cours(nomfich,wxFile::read);
    bool succes=fichier_en_cours.IsOpened();
    if (succes)
        {
        int L=0;
        liste_joueurs().clear();
        Tpersonnalite p(wxT("sans nom"));
        while (L<fichier_en_cours.Length())
                {
                L+=fichier_en_cours.Read(&p,sizeof(p));
                liste_joueurs().push_back(p);
                }
        Machine2().nom=liste_joueurs()[1].extrait_nom(); // Le premier de la liste est toujours baMACHINE1
        Machine1().adversaire.nom=Machine2().nom;
        Machine1().affecte_personnalite();
        Machine2().adversaire.nom=baMACHINE1;
        Machine2().affecte_personnalite();
        if (init_done)
            if (PersoJoueur->IsShown())
                {
                PersoJoueur->Met_a_jour_ChoixPerso();
                PersoJoueur->Refresh();
                }
        }
        else
            Dialogues->AppendText(tr.trad(wxT("Erreur: impossible d'ouvrir le fichier "))+NomFichier);
    Refresh();
    return succes;
}
//---------------------------------------------------------------------------
void MainFrame::FileOpen(wxCommandEvent& WXUNUSED(event) )
{
    Traducteur tr;
    wxFileDialog dialog
                 (
                    this,
                    tr.trad(wxT("Ouvrir un fichier de personnalités")),
                    wxEmptyString,
                    wxEmptyString,
                    wxString(tr.trad(wxT("Fichiers batnav"))+wxT("(*.batnav)|*.batnav|")+tr.trad(wxT("Tous fichiers"))+wxT("(*.*)|*.*"))
                 );
    dialog.CentreOnParent();
    dialog.SetDirectory(DonneesVarDir);
    if (dialog.ShowModal() == wxID_OK)
        {
        DonneesVarDir=dialog.GetDirectory();
        NomFichier=dialog.GetFilename();
        if(!charge_fichier(NomComplet()))
                {
                Dialogues->AppendText(wxT("Fichiers absent"));
                liste_joueurs().liste_par_defaut();
                };
        }
}
//---------------------------------------------------------------------------
//Sauve le fichier des personnalités
void MainFrame::FileSave(wxCommandEvent& event)
{
    wxFile fichier_en_cours(NomComplet(),wxFile::write);
    if (liste_joueurs().size()==0) liste_joueurs().liste_par_defaut();
    for (unsigned int i=0;i<liste_joueurs().size();i++)
        fichier_en_cours.Write(&liste_joueurs()[i],sizeof(Tpersonnalite));
    Refresh();
}
        //---------------------------------------------------------------------------
void MainFrame::FileSaveAs(wxCommandEvent& event)
{
    Traducteur tr;
    wxFileDialog dialog(this,
                        tr.trad(wxT("Enregistrer les profiles actifs")),
                        wxEmptyString,
                        tr.trad(wxT("sans titre"))+wxT(".batnav"),
                        wxString(tr.trad(wxT("Fichiers batanav"))+wxT("(*.batnav)|*.batnav|")+tr.trad(wxT("Tous fichiers"))+wxT("(*.*)|*.*")),
                        wxFD_SAVE|wxFD_OVERWRITE_PROMPT);

    dialog.SetFilterIndex(0);
    dialog.CentreOnParent();
    dialog.SetDirectory(DonneesVarDir);

    if (dialog.ShowModal() == wxID_OK)
    {
// enregistrement du fichier Batnav sélectionné.
    DonneesVarDir=dialog.GetDirectory();
    NomFichier=dialog.GetFilename();
    FileSave(event);
    }
    Refresh();
}
//---------------------------------------------------------------------------
void MainFrame::OnPaint(wxPaintEvent& event)
{
    wxPaintDC dc(this);
    rafraichit();
}
//---------------------------------------------------------------------------
void MainFrame::rafraichit()
{
if (init_done)
  {
        Traducteur tr;
        bool calcul_en_cours=superviseur::partie_en_cours();
    if (item_menu_change)
        {
        wxWindow*  ProvFen=FindWindow(idLabEchap);
        ProvFen->Enable(calcul_en_cours);
        wxMenuBar* Menuprov=GetMenuBar();
         // Traduit les titres des enfants
        RenommeEnfants(this);
        // Traduit les items des menus
        // Titres de menus
        size_t nb_menus=Menuprov->GetMenuCount();
        for (size_t i=0;i<nb_menus;i++)
            Menuprov->SetMenuLabel(i,tr.trad_tout(Menuprov->GetMenuLabel(i)));
        //Items de chaque menu
        Menuprov->SetLabel(ID_DIALOGS_FILE_SAVE_AS,tr.trad_tout(wxT("Enregistrer &sous...")));
        Menuprov->SetLabel(ID_DIALOGS_FILES_OPEN,tr.trad_tout(wxT("&Ouvrir")));
        Menuprov->SetLabel(ID_DIALOGS_FILE_SAVE,tr.trad_tout(wxT("&Enregistrer")));
        Menuprov->SetLabel(idMenuProprietes,tr.trad_tout(wxT("&Qualités de la grille")));
        Menuprov->SetLabel(idMenuCalcule,tr.trad_tout(wxT("Lance une partie")));
        Menuprov->SetLabel(idMenuStop,tr.trad_tout(wxT("Arrête")));
        Menuprov->SetLabel(idMenuPerso,tr.trad_tout(wxT("&Personnalité")));
        Menuprov->SetLabel(idMenuQuit,tr.trad_tout(wxT("Quitter")));
        Menuprov->SetLabel(idMenuMachHom,tr.trad_tout(wxT("Machine <-> homme")));
        Menuprov->SetLabel(idMenuMachMach,tr.trad_tout(wxT("Machine <-> Machine")));
        Menuprov->SetLabel(idMenuMachMach100,tr.trad_tout(wxT("Machine <-> Machine ("+Param_nb_de_boucles+" parties)")));
        Menuprov->SetLabel(idMenuDisclaimer, tr.trad(wxT("Avertissement")));
        Menuprov->SetLabel(idMenuAbout, tr.trad_tout(wxT("A propos")));
        Menuprov->SetLabel(idMenuHelp, tr.trad_tout(wxT("Aide")));
        Menuprov->SetLabel(idMenufr,tr.trad_tout(wxT("Français")));
        Menuprov->SetLabel(idMenuen,tr.trad_tout(wxT("English")));
        Menuprov->SetLabel(idMenues,tr.trad_tout(wxT("Espagnol")));

        // Boutons actifs ou non sur la barre d'outils
        langues langue_en_cours=tr.fixe_langue();
        Menuprov->Check(idMenufr,(langue_en_cours==fr));
        Menuprov->Check(idMenuen,(langue_en_cours==ang));
        Menuprov->Check(idMenues,(langue_en_cours==esp));
        Menuprov->Check(idMenuCalcule,(calcul_en_cours));
        Menuprov->Check(idMenuStop,(!calcul_en_cours));// Sous Linux semble provoquer l'émission de l'évènement correspondant

        wxToolBar* Toolbarprov=GetToolBar();
        Toolbarprov->ToggleTool(idMenufr,langue_en_cours==fr);
        Toolbarprov->ToggleTool(idMenuen,langue_en_cours==ang);
        Toolbarprov->ToggleTool(idMenues,langue_en_cours==esp);
        // Sous Linux, toggle inactive (comme attendu) le bouton correspondant
        // mais pas sous Windows d'où la nécessité d'ajouter EnableTool
        Toolbarprov->ToggleTool(idMenuCalcule,calcul_en_cours);
        //Toolbarprov->EnableTool(idMenuCalcule,!calcul_en_cours);
        Toolbarprov->ToggleTool(idMenuStop,!calcul_en_cours);
        //Toolbarprov->EnableTool(idMenuStop,calcul_en_cours);
        Toolbarprov->SetToolShortHelp(ID_DIALOGS_FILES_OPEN,tr.trad_tout(wxT("&Ouvrir")));
        Toolbarprov->SetToolShortHelp(ID_DIALOGS_FILE_SAVE,tr.trad_tout(wxT("Sauve le fichier en cours")));
        Toolbarprov->SetToolShortHelp(idMenuCalcule,tr.trad_tout(wxT("Lance une partie")));
        Toolbarprov->SetToolShortHelp(idMenuStop,tr.trad_tout(wxT("Arrête")));
        Toolbarprov->SetToolShortHelp(idMenuHelp, tr.trad_tout(wxT("Aide")));
        Toolbarprov->SetToolShortHelp(idMenuPerso, tr.trad_tout(wxT("Personnalité")));
        Toolbarprov->SetToolShortHelp(idMenuQuit,tr.trad_tout(wxT("Quitter")));
        item_menu_change=false;
        }
    if (!calcul_en_cours) //Seules les valeurs variables en cours de calcul sont rafraichies
        {
        //Ajuste la taille des contrôles
        wxPoint pos=FaitReelle_Pos(wxPoint(300,750),this);
        wxSize taille=FaitReelle_Taille(wxSize(700,250),this);
        BoutonsRadio->SetSize(wxRect(pos,taille));
        pos=FaitReelle_Pos(wxPoint(400,30),this);
        taille=FaitReelle_Taille(wxSize(300,50),this);
        LabEchap->SetSize(wxRect(pos,taille));

            // Boutons réponse
        pos=FaitReelle_Pos(wxPoint(10,10),BoutonsRadio);
        taille=FaitReelle_Taille(wxSize(140,320),BoutonsRadio);
        Boutaleau->SetSize(wxRect(pos,taille));
        pos=FaitReelle_Pos(wxPoint(10,340),BoutonsRadio);
        Boutouche->SetSize(wxRect(pos,taille));
        pos=FaitReelle_Pos(wxPoint(10,670),BoutonsRadio);
        Boutcoule->SetSize(wxRect(pos,taille));

            // Boutons radios choix de la forme et de la taille des bateaux
        pos=FaitReelle_Pos(wxPoint(160,10),BoutonsRadio);
        taille=FaitReelle_Taille(wxSize(190,960),BoutonsRadio);
        ChoixForme->SetSize(wxRect(pos,taille));
        for (int i=0;i<3;i++) ChoixForme->SetString(i,tr.trad(nomforme[i]));
        ChoixForme->Enable(!superviseur::partie_initialisee());
        pos=FaitReelle_Pos(wxPoint(360,10),BoutonsRadio);
        ChoixTaille->SetSize(wxRect(pos,taille));
        for (int i=0;i<3;i++) ChoixTaille->SetString(i,tr.trad(nomtaille[i]));
        ChoixTaille->Enable(!superviseur::partie_initialisee());

            // Fenêtre de dialogues
        pos=FaitReelle_Pos(wxPoint(560,10),BoutonsRadio);
        taille=FaitReelle_Taille(wxSize(400,960),BoutonsRadio);
        Dialogues->SetSize(wxRect(pos,taille));
        Dialogues->SetInsertionPointEnd();

        // Fixe la  taille des échiquiers
        pos=FaitReelle_Pos(wxPoint(260,100),this);
        taille=FaitReelle_Taille(wxSize(390,660),this);
        Machine2().lui.son_tableau.echiquier->SetSize(wxRect(pos,taille));
        pos=FaitReelle_Pos(wxPoint(625,100),this);
        Machine2().adversaire.son_tableau.echiquier->SetSize(wxRect(pos,taille));
        pos=FaitReelle_Pos(wxPoint(10,533),this);
        taille=FaitReelle_Taille(wxSize(260,433),this);
        Machine1().lui.son_tableau.echiquier->SetSize(wxRect(pos,taille));
        pos=FaitReelle_Pos(wxPoint(10,100),this);
        Machine1().adversaire.son_tableau.echiquier->SetSize(wxRect(pos,taille));
        }
  }
}
//---------------------------------------------------------------------------

void  MainFrame::OnProprietes(wxCommandEvent& event)
{
        //tests
        Traducteur tr;
        Dialogues->AppendText(tr.trad(wxT("jeu compact"))+wxT("=")+wxString::Format(wxT("%3.4f"),Scrutateur::compacite_flottille(&Machine2().lui))+LF);
        Dialogues->AppendText(tr.trad(wxT("jeu marginal"))+wxT("=")+wxString::Format(wxT("%3.4f"),Scrutateur::marginalite_flottille(&Machine2().lui))+LF);
 }
//---------------------------------------------------------------------------
void  MainFrame::OnCalcule(wxCommandEvent& event)
{
        // ne lance la partie que si le joueur 2 est machine ou si le joueur humain a préparé sa flottille
        // si la partie n'est pas initialisée, nettoie les tableaux des deux joueurs.
        // si la partie est valide met partie_en_cours à vrai
        using namespace superviseur;
    if (!partie_en_cours())
    {
        partie_en_cours()=true;
        interruption_demandee()=false;
        if (!partie_initialisee())
                {Machine1().coup_deponge();
                Machine2().coup_deponge();
                Machine1().affecte_personnalite();
                Machine2().affecte_personnalite();
                partie_initialisee()=true;
                }
        item_menu_change=true;
        Refresh();
        Update();       // force l'affichage correct des différents boutons.
        Canvas1->visible_on_off(!donneesStrat.machine_contre_humain());
        bool on_joue=(donneesStrat.machine_contre_humain());
        int nb_de_boucles=(donneesStrat.mode_auto()?PARAM_NB_BOUCLES_MODE_AUTO:1);
        LabEchap->Enable(nb_de_boucles>1); // LabEchap n'est activé que si la partie est en automatique
        Refresh();
        if (!on_joue)
            for (int i=0;i<nb_de_boucles;i++)
                    {
                    partie_en_cours()=true;
                    Dialogues->SetFocus();
                    joue_une_partie_machine_machine();
                    Machine1().coup_deponge();
                    Machine2().coup_deponge();
                    if (interruption_demandee()) i=nb_de_boucles;
                    }
         else
            {
            on_joue=joueur_humain_cree_flottille();
            if (on_joue) joue_partie_machine_humain();
            else partie_en_cours()=false;
            }
        LabEchap->Enable(false);
        item_menu_change=true;
        Refresh();
        Update();       // force l'affichage correct des différents boutons.
    }
}
//---------------------------------------------------------------------------
void MainFrame::OnChoixForme(wxCommandEvent& event)
{
        nom_des_formes nf;
        Traducteur tr;
        switch (ChoixForme->GetSelection())
                {
                case 1:donneesStrat.fixe_forme_bateaux(tordus);break;
                case 2:donneesStrat.fixe_forme_bateaux(par_les_sommets);break;
                default :donneesStrat.fixe_forme_bateaux(lineaires);
                };
        Dialogues->AppendText(tr.trad(wxT("Nouvelle forme des bateaux:"))+ nf.nom_de(donneesStrat.forme_bateaux())+LF);
        Refresh();
}
//---------------------------------------------------------------------------
void MainFrame::OnChoixTaille(wxCommandEvent& event)
{
        Traducteur tr;
        switch (ChoixTaille->GetSelection())
                {
                case 0:taille_echiquier_courant()=5 ;break;
                case 1:taille_echiquier_courant()=10;break;
                default :taille_echiquier_courant()=donneesStrat.taille_max_admissible_grille;
                };
        donneesStrat.ajuste_flottille_a_grille();
        Machine1().lui.son_tableau.resize();
        Machine1().adversaire.son_tableau.resize();
        Machine2().lui.son_tableau.resize();
        Machine2().adversaire.son_tableau.resize();
        Dialogues->AppendText(tr.trad(wxT("Nouvelle grille"))+wxT(" : ")+wxString::Format(wxT("%2i"),taille_echiquier_courant())+LF);
        //RaviveExecute(Sender);
        Refresh();
}
//---------------------------------------------------------------------------
void  MainFrame::OnStop(wxCommandEvent& event)
{
        Traducteur tr;
        if (donneesStrat.machine_contre_humain())
                {
                Dialogues->AppendText(tr.trad(wxT("Partie interrompue"))+tr.trad(wxT(" par "))+Machine2().nom);
                superviseur::fin_de_partie(&Machine1());
                }
                else
                {// si une partie en automatique est lancée
                 // attendra la fin du coup en cours pour arrêter
                superviseur::interruption_demandee()=true;
                Dialogues->AppendText(tr.trad(wxT("Partie interrompue")));
                }
}
//---------------------------------------------------------------------------

void  MainFrame::OnMachHom(wxCommandEvent& event)
{
        donneesStrat.machine_contre_humain()=true;
        donneesStrat.mode_auto()=false;
}
//---------------------------------------------------------------------------

void  MainFrame::OnMachMach100(wxCommandEvent& event)
{
        donneesStrat.machine_contre_humain()=false;
        donneesStrat.mode_auto()=true;
}
//---------------------------------------------------------------------------

void  MainFrame::OnMachMach(wxCommandEvent& event)
{
        donneesStrat.mode_auto()=false;
        donneesStrat.machine_contre_humain()=false;
}
//---------------------------------------------------------------------------

void  MainFrame::OnFichePerso(wxCommandEvent& event)
{
        if (PersoJoueur->IsShown())
            PersoJoueur->Show(false);
            else
            {
                PersoJoueur->Show(true);
                PersoJoueur->Met_a_jour_ChoixPerso();
                PersoJoueur->Refresh();
            }
}
//---------------------------------------------------------------------------
void  MainFrame::OnBoutaleau(wxCommandEvent& event)
{
    Traducteur tr;
    Dialogues->AppendText(tr.trad(wxT("A l'eau!"))+LF);
    superviseur::humain_donne_reponse(a_leau,jouee);
 }
//---------------------------------------------------------------------------
void  MainFrame::OnBoutouche(wxCommandEvent& event)
{
    Traducteur tr;
    Dialogues->AppendText(tr.trad(wxT("Touché!"))+LF);
    superviseur::humain_donne_reponse(touche,touchee);
}
//---------------------------------------------------------------------------
void  MainFrame::OnBoutcoule(wxCommandEvent& event)
{
    Traducteur tr;
    Dialogues->AppendText(tr.trad(wxT("Coulé!"))+LF);
    superviseur::humain_donne_reponse(coule,touchee);
}
